				--[[
---------RP-Lua by Yasday----------
--------------v1.0.0---------------
===================================
				--]]
print("255255255RolePlay Lua by Yasday.")
print("255000000Loading...")

map_config_path = "sys/lua/RolePlay/map_config.txt"
languages_path = "sys/lua/RolePlay/languages.txt"
admin_file_path = "sys/lua/RolePlay/groups.txt"
save_file_path = "sys/lua/RolePlay/saves.sav"

addhook([[always]], [[always_hook]])
addhook([[attack]], [[attack_hook]])
addhook([[buildattempt]], [[buildattempt_hook]])
addhook([[die]], [[die_hook]])
addhook([[drop]], [[drop_hook]])
addhook([[hit]], [[hit_hook]])
addhook([[join]], [[join_hook]])
addhook([[kill]], [[kill_hook]])
addhook([[leave]], [[leave_hook]])
addhook([[menu]], [[menu_hook]])
addhook([[minute]], [[minute_hook]])
addhook([[ms100]], [[ms100_hook]])
addhook([[projectile]], [[projectile_hook]])
addhook([[say]], [[say_hook]])
addhook([[second]], [[second_hook]])
addhook([[serveraction]], [[serveraction_hook]])
addhook([[spawn]], [[spawn_hook]])
addhook([[spray]], [[spray_hook]])
addhook([[team]], [[team_hook]])
addhook([[use]], [[use_hook]])
addhook([[usebutton]], [[usebutton_hook]])
addhook([[walkover]], [[walkover_hook]])

lang = {}
languages = ""
default_lang = "en"
languages2 = {}
autospecbots = false
freeb = false
spawn_protect_time = 3
VIPList = {}
car_image = "sys/lua/RolePlay/gfx/car.png"
plant = {{},n = 0,img = "sys/lua/RolePlay/gfx/plant1.png",img2 = "sys/lua/RolePlay/gfx/plant2.png",img3 = "sys/lua/RolePlay/gfx/plant3.png",area = {x = {},y = {}}}
roof = {{},n = 0,img = "sys/lua/RolePlay/gfx/nothing.png"}
npc = {{},n = 0,img = "sys/lua/RolePlay/gfx/npc.png"}
train = {{},n = 0,img = "sys/lua/RolePlay/gfx/train.png",railimage = "sys/lua/RolePlay/gfx/rail.png"}
house = {n = 0}
zones = {n = 0}
images = {{},{}}
weapons_n = { }
group = {}
_image = image
first_time_map = false
first_time_id = 1
plant_tile_frame = 0

function f_exists(f)
	local file = io.open(f,"r")
	if file == nil then return false else file:close() return true end
end

function image(path,x,y,l,p)
	local img = _image(path,x,y,l,p)
	table.insert(images[1],path)
	table.insert(images[2],img)
	return img
end

function house.create(price,dname,...)
	local a = {...}
	house.n = house.n + 1
	local id = house.n
	house[id] = {
		owner = 0,
		price = price,
		dname = dname,
		button = a,
	}
	for i,v in ipairs(house[id].button) do
		if type(v) == "table" then
			for ii,vv in ipairs(v) do
				house[id].button[ii] = vv
			end
		end
	end
end

function zones.create(x,y,name)
	if not x then x = {} end
	if not y then y = {} end
	if not name then name = "Zone" end
	zones.n = zones.n + 1
	local id = zones.n
	zones[id] = {
		x = x,
		y = y,
		name = name,
	}
end

function toTable(ts,match,p)
	if not match then match = "%s" end
	if not p then match = "[^"..match.."]+" end
	local t = {}
	for w in string.gmatch(ts,match) do
		table.insert(t,w)
	end 
	return t
end

function decomment( s, k )
	s = file_string( s )
	k = k or "//"
	local str = ""
	local s = toTable( s, "\n" )
	for i, v in ipairs( s ) do
		if string.find( v, k ) then
			str = str .. string.sub( v, 1, select( 1, string.find( v, k ) ) - 1) .. "\n"
		else
			str = str .. v .. "\n"
		end
	end
	return str
end

function file_string(file)
	local c = ""
	for lines in io.lines(file) do
		c = c .. lines .. "\n"
	end
	return c
end

function toboolean(txt)
	if txt == "true" then
		return true
	elseif txt == "false" then
		return false
	elseif txt == "nil" then
		return nil
	end
end

function roof.create(x,y,wx,img)
	img = img or roof.img
	roof.n = roof.n + 1
	local tbl = {}
	x = x * 32 + 16
	y = y * 32 + 16
	local id = roof.n
	for pl = 1,32 do
		roof[id][pl] = {
			x = x,
			y = y,
			w = wx,
			img = image(img,x,y,3,pl),
			oimg = img,
		}
		imagepos(roof[id][pl].img,x,y,0)
	end
end

function npc.create(x,y,mode,rot,spec,img,ttx,tty,tprc,txt,bw,bp)
	if not mode then mode = 0 end
	if not rot then rot = 0 end
	if not spec then spec = 0 end
	if not img or img == "" then img = npc.img end
	npc.n = npc.n + 1
	local id = npc.n
	npc[id] = {
		x = x,
		y = y,
		tx = (x - (x % 32)) / 32,
		ty = (y - (y % 32)) / 32,
		mode = mode,
		menu = 0,
		img = image(img,x,y,3),
		rot = rot,
		times = 0,
		ble = {false,0},
		special = spec,
		ttx = ttx,
		tty = tty,
		tprc = tprc,
		txt = txt,
		bw = bw,
		bp = bp,
		bn = ""
	}
	if npc[id].bw then
		for i,v in ipairs(npc[id].bw) do
			if v ~= 0 then
				npc[id].bn = npc[id].bn..itemtype(v,"name").."|$"..npc[id].bp[i]..","
			else
				npc[id].bn = npc[id].bn..","
			end
		end
		npc[id].bn = string.sub(npc[id].bn, 1, -1)
	end
	if npc[id].special == 8 then
		npc[id].fieldimg = image("sys/lua/RolePlay/gfx/field.png", (npc[id].tx) * 32 + 16, (npc[id].ty + 2) * 32 + 16, 0)
		npc[id].pa = false
		npc[id].ximg = {}
	end
	imagepos(npc[id].img,x,y,npc[id].rot)
end

function train.create(x,y,rot,back,c21,c22,c23,c31,c32,c33,c41,c42,c43,c51,c52,c53,c61,c62,c63,c71,c72,c73,c81,c82,c83,c91,c92,c93,c101,c102,c103,img,b)
	if not img or img == "normal" or img == "standart" then img = train.img end
	if not back then back = false end
	if not c31 then c31 = c21 end
	if not c32 then c32 = c22 end
	if not c33 then c33 = c23 end
	if not c41 then c41 = c31 end
	if not c42 then c42 = c32 end
	if not c43 then c43 = c33 end
	if not c51 then c51 = c41 end
	if not c52 then c52 = c42 end
	if not c53 then c53 = c43 end
	if not c61 then c61 = c51 end
	if not c62 then c62 = c52 end
	if not c63 then c63 = c53 end
	if not c71 then c71 = c61 end
	if not c72 then c72 = c62 end
	if not c73 then c73 = c63 end
	if not c81 then c81 = c71 end
	if not c82 then c82 = c72 end
	if not c83 then c83 = c73 end
	if not c91 then c91 = c81 end
	if not c92 then c92 = c82 end
	if not c93 then c93 = c83 end
	if not c101 then c101 = c91 end
	if not c102 then c102 = c92 end
	if not c103 then c103 = c93 end
	if b == true then b = false elseif b == nil then b = false elseif b == false then b = true end
	train.n = train.n + 1
	local id = train.n
	train[id] = {
		p1 = 0,
		p2 = 0,
		p3 = 0,
		p4 = 0,
		x = x * 32 + 16,
		y = y * 32 + 16,
		img = img,
		sp = 1,
		t = 0,
		tr = false,
		tx = x,
		ty = y,
		rot = rot,
		back = false,
		ticket = back,
		c1 = {x,y,rot},
		c2 = {c21,c22,c23},
		c3 = {c31,c32,c33},
		c4 = {c41,c42,c43},
		c5 = {c51,c52,c53},
		c6 = {c61,c62,c63},
		c7 = {c71,c72,c73},
		c8 = {c81,c82,c83},
		c9 = {c91,c92,c93},
		c10 = {c101,c102,c103},
		didrails = false,
		railimgs = {},
		tsa = b
	}
	train[id].img = image(train[id].img,x * 32 + 16,y * 32 + 16,3)
	imagepos(train[id].img,train[id].x,train[id].y,train[id].rot)
end

function group.create(name,color,rights)
	local id = #group + 1
	group[id] = {
		name = name,
		color = color,
		usgn = {},
		rights = {}
	}
	if rights == "z" then rights = "abcdefghijklmnopqrstuvwxyz" end
	for w in string.gmatch(rights,".") do
		table.insert(group[id].rights, w)
	end
end

function group.add(name,usgn)
	for id = 1, #group do
		if group[id] then
			if group[id].name == name then
				table.insert(group[id].usgn, usgn)
			end
		end
	end
end

function dsfile(file)
	local mapd = false
	file = decomment(file)
	for ___o,lines in ipairs(toTable(file,"\n")) do
		if map("name") == lines then
			local f = f_exists("sys/lua/RolePlay/map_cfgs/"..map("name")..".txt","r")
			if f then
				dfile("sys/lua/RolePlay/map_cfgs/"..map("name")..".txt")
				if f_exists("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt") then
					dfile("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt")
				end
			else
				if f_exists("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt") then
					dfile("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt")
				end
			end
			mapd = true
			return
		end
	end
	if mapd == false then
		local f = f_exists("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt","r")
		if not f then
			local fi = io.open("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt","w")
			if fi ~= nil then
				fi:write("true")
				fi:close()
			end
			dfile("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt")
		end
	end
	dfile("sys/lua/RolePlay/rp_standart_config.txt")
end

function fileline(file,line)
	local fil = io.open(file,"r")
	local lin = 0
	local tbl = {}
	if fil ~= nil then
		for lines in io.lines(file) do
			lin = lin + 1
			tbl[lin] = lines
		end
		fil:close()
	else
		return nil
	end
	return tbl[line]
end
	
function dfile(file)
	local of = file
	file = decomment( file )
	if fileline(of,1) == "true" then
		first_time_map = true
		first_time_id = 1
		local f = io.open(file,"w")
		f:write("")
		f:close()
		return
	end
	for ___o,lines in ipairs(toTable( file, "\n" )) do
		local line = toTable(lines, ":")
		if not string.sub(string.lower(lines),1,7) == "say_npc" and not not string.sub(string.lower(lines),1,5) == "zones" then
			lines = string.lower(lines)
			line = toTable(lines)
		end
		if line[1] == "npc" then
			local x = tonumber(line[2]) * 32 + 16
			local y = tonumber(line[3]) * 32 + 16
			local rot = tonumber(line[4])
			local mode = tonumber(line[5])
			local spec = tonumber(line[6])
			local img = line[7]
			if spec == nil then spec = 0 end
			npc.create(x,y,mode,rot,spec,img)
		elseif line[1] == "teleport_npc" then
			local x = tonumber(line[2]) * 32 + 16
			local y = tonumber(line[3]) * 32 + 16
			local ttx = tonumber(line[4]) * 32 + 16
			local tty = tonumber(line[5]) * 32 + 16
			local tprc = tonumber(line[6])
			local rot = tonumber(line[7])
			local mode = tonumber(line[8])
			local img = line[9]
			if not tprc then tprc = 1000 end
			npc.create(x,y,mode,rot,5,img,ttx,tty,tprc)
		elseif line[1] == "say_npc" then
			local x = tonumber(line[2]) * 32 + 16
			local y = tonumber(line[3]) * 32 + 16
			local rot = tonumber(line[4])
			local mode = tonumber(line[5])
			local col = line[7]
			local tx = string.sub(lines,string.len(line[1]) + string.len(line[2]) + string.len(line[3]) + string.len(line[4]) + string.len(line[5]) + string.len(line[6]) + string.len(line[7]) + 8)
			local img = line[6]
			local spec = 6
			if img == "standart" or img == "normal" then img = npc.img end
			npc.create(x,y,mode,rot,6,img,nil,nil,nil,""..col..tx)
		elseif line[1] == "sell_npc" then
			local x = tonumber(line[2]) * 32 + 16
			local y = tonumber(line[3]) * 32 + 16
			local rot = tonumber(line[4])
			local mode = tonumber(line[5])
			local ids1 = tonumber(line[6])
			local ids2 = tonumber(line[7])
			local ids3 = tonumber(line[8])
			local ids4 = tonumber(line[9])
			local ids5 = tonumber(line[10])
			local ids6 = tonumber(line[11])
			local ids7 = tonumber(line[12])
			local ids8 = tonumber(line[13])
			local ids9 = tonumber(line[14])
			local prc1 = tonumber(line[15])
			local prc2 = tonumber(line[16])
			local prc3 = tonumber(line[17])
			local prc4 = tonumber(line[18])
			local prc5 = tonumber(line[19])
			local prc6 = tonumber(line[20])
			local prc7 = tonumber(line[21])
			local prc8 = tonumber(line[22])
			local prc9 = tonumber(line[23])
			local img = line[24]
			npc.create(x,y,mode,rot,7,img,nil,nil,nil,nil,{ ids1, ids2, ids3, ids4, ids5, ids6, ids7, ids8, ids9 }, { prc1, prc2, prc3, prc4, prc5, prc6, prc7, prc8, prc9 })
		elseif line[1] == "rail_image" then
			train.railimage = line[2]
		elseif line[1] == "spawnprotection" then
			spawn_protect_time = tonumber(line[2])
		elseif line[1] == "house" then
			local dname = line[3]
			local price = tonumber(line[2])
			local p = {}
			for x = 4,#line do
				if #line > 4 then table.insert(p,line[x]) elseif #line == 4 then p = {line[x]} break end
			end
			house.create(price,dname,p)
		elseif line[1] == "zone" then
			local x1 = tonumber(line[2])
			local y1 = tonumber(line[3])
			local x2 = tonumber(line[4])
			local y2 = tonumber(line[5])
			local name = string.sub(lines,string.len(line[1]) + string.len(line[2]) + string.len(line[3]) + string.len(line[4]) + string.len(line[5]) + 6)
			zones.create({x1,x2},{y1,y2},name)
		elseif line[1] == "train" then
			local ticket = toboolean(line[2])
			local img = line[3]
			local x = tonumber(line[4])
			local y = tonumber(line[5])
			local rot = tonumber(line[6])
			local c21 = tonumber(line[7])
			local c22 = tonumber(line[8])
			local c23 = tonumber(line[9])
			local c31 = tonumber(line[10])
			local c32 = tonumber(line[11])
			local c33 = tonumber(line[12])
			local c41 = tonumber(line[13])
			local c42 = tonumber(line[14])
			local c43 = tonumber(line[15])
			local c51 = tonumber(line[16])
			local c52 = tonumber(line[17])
			local c53 = tonumber(line[18])
			local c61 = tonumber(line[19])
			local c62 = tonumber(line[20])
			local c63 = tonumber(line[21])
			local c71 = tonumber(line[22])
			local c72 = tonumber(line[23])
			local c73 = tonumber(line[24])
			local c81 = tonumber(line[25])
			local c82 = tonumber(line[26])
			local c83 = tonumber(line[27])
			local c91 = tonumber(line[28])
			local c92 = tonumber(line[29])
			local c93 = tonumber(line[30])
			local c101 = tonumber(line[31])
			local c102 = tonumber(line[32])
			local c103 = tonumber(line[33])
			local b = toboolean(line[34])
			train.create(x,y,rot,ticket,c21,c22,c23,c31,c32,c33,c41,c42,c43,c51,c52,c53,c61,c62,c63,c71,c72,c73,c81,c82,c83,c91,c92,c93,c101,c102,c103,img,b)
		elseif line[1] == "roof" then
			local x = tonumber(line[2])
			local y = tonumber(line[3])
			local wx = tonumber(line[4])
			local img = line[5]
			if img == "" then img = nil end
			roof.create(x,y,wx,img)
		elseif line[1] == "car_image" then
			car_image = line[2]
		elseif line[1] == "plant_mode1" then
			plant.img = line[2]
		elseif line[1] == "plant_mode2" then
			plant.img2 = line[2]
		elseif line[1] == "plant_mode3" then
			plant.img3 = line[2]
		elseif line[1] == "npc_image" then
			npc.img = line[2]
		elseif line[1] == "train_image" then
			train.img = line[2]
		elseif line[1] == "plantframe" then
			plant_tile_frame = tonumber(line[2])
		elseif line[1] == "autospec_bots" then
			autospecbots = toboolean(line[2])
		end
	end
	print("000255000Loaded cfg \""..of.."\"")
end

function ddfile(file)
	file = decomment(file)
	for ___o,lines in ipairs(toTable(file,"\n")) do
		local line = toTable(lines, ":")
		if line[1] == "language" then
			local langu = line[2]
			lang[langu] = {}
			table.insert(languages2,langu)
			dddfile("sys/lua/RolePlay/languages/"..langu..".txt",langu)
		elseif line[1] == "standard" then
			default_lang = line[2]
		end
	end
end

function dddfile(file,ll)
	file = decomment(file)
	for ___o,lines in ipairs(toTable(file,"\n")) do
		if string.sub(lines,1,1) == "#" then
			if languages == "" then
				languages = string.sub(lines,2,string.len(lines))..","..languages
			elseif string.sub(languages,-1) == "," then
				languages = languages..string.sub(lines,2,string.len(lines))
			else
				languages = languages..","..string.sub(lines,2,string.len(lines))
			end
		else
			table.insert(lang[ll],lines)
		end
	end
end

function dafile(file)
	local of = file
	file = decomment(file)
	for ___o,lines in ipairs(toTable(file,"\n")) do
		local line = toTable(lines,":")
		if line[1] == "group" then
			if line[3] == "none" or line[3] == "standart" then line[3] = nil end
			group.create(line[2],line[3],line[4])
		elseif line[1] == "add" then
			group.add(line[2],tonumber(line[3]))
		end
	end
	print("000255000Loaded admin file \""..of.."\"")
end

function addspace(x,y)
	if type(x) == "table" or type(x) == "number" then
		if type(y) == "table" or type(y) == "number" then
			if type(x) == "table" and type(y) == "table" then
				for _,px in ipairs(x) do
					table.insert(plant.area.x,px)
				end
				for _,py in ipairs(y) do
					table.insert(plant.area.y,py)
				end
			elseif type(x) == "table" and type(y) ~= "table" then
				for _,px in ipairs(x) do
					table.insert(plant.area.x,px)
				end
				table.insert(plant.area.y,y)
			elseif type(x) ~= "table" and type(y) == "table" then
				for _,py in ipairs(y) do
					table.insert(plant.area.y,py)
				end
				table.insert(plant.area.x,x)
			elseif type(x) ~= "table" and type(y) ~= "table" then
				table.insert(plant.area.x,x)
				table.insert(plant.area.y,y)
			end
		end
	end
end

dsfile(map_config_path)
ddfile(languages_path)
dafile(admin_file_path)

function Array(value,mz,ez)
	local array = {}
	if value == nil then value = 0 end
	if not mz then mz = 32 end
	if not ez then ez = 1 end
	for i = ez,mz do
		array[i] = value
	end
	return array
end

math.randomseed(os.time())
train.ticket = Array(false)
language = Array(default_lang)
money = Array(0)
pln = Array("")
wfa = Array({false,"",""})
ftr = Array({false,"",""})
tsb = Array(false)
ct = Array(false)
vip = Array(false)
admk = Array(false)
arrest = Array(false)
mute = Array(false)
license = Array(false)
didonetime = Array(false)
arrest.x = Array(0)
arrest.y = Array(0)
arrest.x.vic = Array(0)
arrest.y.vic = Array(0)
spawnprotect = Array(true)
spawnprotect.t = Array(0)
page = Array(0)
rpage = Array(0)
bcol = Array(1)
sell = Array(0)
blv = {}
blv[1] = Array(1)
blv[2] = Array(1)
myspeed = Array(5)
yspeed = Array(5)
speed = Array(false)
health = Array(false)
myhealth = Array(125)
yhealth = Array(125)
bank = Array(0)
pos_x = Array(0)
pos_y = Array(0)
die_x = Array(0)
die_y = Array(0)
hnpc = Array(false)
drop_spec = Array(false)
car = Array(false)
car.x = Array(-1)
car.y = Array(-1)
car.tx = Array(-1)
car.ty = Array(-1)
car.sp = Array(0)
car.gi = Array(0)
car.is = Array(false)
car.img = Array(0)
car.kills = Array(0)
car.bla = Array(0)
killwho = Array(0)
hitman = Array(false)
hitman.k = Array({USP = 0,Deagle = 0,0,hitman = 0})
hitman.m = {}
for i = 1,5 do
	if i == 1 then
		hitman.m[i] = Array({false,"Not Done",false})
	else
		hitman.m[i] = Array({false,"Not Aviable",false})
	end
end
hitman.rob = {false,0,0,0,0}
tsx = nil
tsy = nil
_math = {}
_menu = menu
_math.sqrt = math.sqrt
_msg = msg
_loadstring = loadstring
sec = 0
h = 0

--[[
	Settings:
--]]
parse([[mp_antispeeder 0]])
parse([[mp_dispenser_health 100]])
parse([[mp_dispenser_money 0]])
parse([[sv_fow 0]])
parse([[sv_friendlyfire 1]])
parse([[sv_lan 0]])
parse([[sv_usgnonly 0]])
parse([[sv_maptransfer 1]])
parse([[sv_spraytransfer 1]])
parse([[sv_gamemode 3]])
parse([[sv_specmode 1]])
parse([[mp_startmoney 0]])
parse([[mp_teamkillpenalty 0]])
parse([[mp_tkpunish 0]])
parse([[mp_idlekick 0]])
parse([[mp_autoteambalance 0]])
parse([[mp_killteambuildings 1]])

function txtyst()
	plant.area = {x = {},y = {}}
	tsx = nil
	tsy = nil
	for x = 0,map("xsize") do
		for y = 0,map("ysize") do
			if entity(x,y,"exists") then
				if entity(x,y,"typename") == "Info_T" then
					if not tsx then tsx = x end
					if not tsy then tsy = y end
				end
			end
			if tile(x,y,"frame") == plant_tile_frame then
				addspace(x,y)
			end
			for id = 1, house.n, 1 do
				if house[id] then
					if entity(x,y,"exists") then
						if entity(x,y,"name") == house[id].dname then
							house[id].dx = x
							house[id].dy = y
							break
						end
					end
				end
			end
		end
	end
end

function loadstring(s)
	_loadstring(s)()
end

for i = 1, 91 do
	weapons_n[i] = itemtype(i, "name") or "EMPTY"
end

function ftrigger(id,...)
	local args = {...}
	ftr[id] = {true,"",args}
end

function answer(id,...)
	local args = {...}
	wfa[id] = {true,"",args}
end

function free_all_images()
	for _,id in ipairs(images[2]) do
		freeimage(id)
	end
	images = {{},{}}
end

function math.sqrt(x,y)
	return _math.sqrt(x^2 + y^2)
end

function msg(col,txt,n2,n3,n4)
	if not txt then txt = "" end
	if not n2 then n2 = "" end
	if not n3 then n3 = "." end
	if not n4 then n4 = "" end
	if type(txt) == "number" then
		for _,pl in ipairs(player(0,"table")) do
			msg2(pl,col..lang[language[pl]][txt]..n2..lang[language[pl]][n3]..n4)
		end
	else
		for _,pl in ipairs(player(0,"table")) do
			msg2(pl,col..txt)
		end
	end
end

function hitlang(id)
	if hitman.m[1][id][1] == false then
		hitman.m[1][id][2] = lang[language[id]][101]
	else
		hitman.m[1][id][2] = lang[language[id]][103]
	end
	if hitman.m[1][id][1] == false and hitman.m[2][id][1] == false then
		hitman.m[2][id][2] = lang[language[id]][102]
	else
		hitman.m[2][id][2] = lang[language[id]][101]
	end
	if hitman.m[2][id][1] == false and hitman.m[3][id][1] == false then
		hitman.m[3][id][2] = lang[language[id]][102]
	elseif hitman.m[2][id][1] == true and hitman.m[3][id][1] == false then
		hitman.m[3][id][2] = lang[language[id]][101]
	else
		hitman.m[3][id][2] = lang[language[id]][103]
	end
	if hitman.m[3][id][1] == false and hitman.m[4][id][1] == false then
		hitman.m[4][id][2] = lang[language[id]][102]
	elseif hitman.m[2][id][1] == true and hitman.m[4][id][1] == false then
		hitman.m[4][id][2] = lang[language[id]][101]
	else
		hitman.m[4][id][2] = lang[language[id]][103]
	end
	if hitman.m[4][id][1] == false and hitman.m[5][id][1] == false then
		hitman.m[5][id][2] = lang[language[id]][102]
	elseif hitman.m[2][id][1] == true and hitman.m[5][id][1] == false then
		hitman.m[5][id][2] = lang[language[id]][101]
	else
		hitman.m[5][id][2] = lang[language[id]][103]
	end
	if hitman.m[1][id][1] == true then
		hitman.m[1][id][2] = lang[language[id]][103]
	end
	if hitman.m[2][id][1] == true then
		hitman.m[2][id][2] = lang[language[id]][103]
	end
	if hitman.m[3][id][1] == true then
		hitman.m[3][id][2] = lang[language[id]][103]
	end
	if hitman.m[4][id][1] == true then
		hitman.m[4][id][2] = lang[language[id]][103]
	end
	if hitman.m[5][id][1] == true then
		hitman.m[5][id][2] = lang[language[id]][103]
	end
end

function hasright(id,right)
	for n = 1, #group do
		if group[n] and isAdmin(id, group[n].usgn) then
			for i,v in ipairs(group[n].rights) do
				if v == right then return true end
			end
		end
	end
	return false
end

function intrain(pl)
	for id = 1,train.n do
		if train[id] then
			if train[id].p1 == pl or train[id].p2 == pl or train[id].p3 == pl or train[id].p4 == pl then
				return true
			end
		end
	end
	return false
end

function kwoo(pl)
	if killwho[pl] == 0 then
		local mr = player(0,"table")[math.random(1,#player(0,"table"))]
		if mr ~= pl then
			if player(mr,"exists") then
				if not hasright(mr, "z") and not hasright(mr, "x") then
					msg2(pl,"255000000"..string.format(lang[language[pl]][119], player(mr,"name")).."@C")
					killwho[pl] = mr
					return true
				end
			end
			return false
		else
			if #player(0,"table") == 1 then
				msg2(pl,"255000000"..lang[language[pl]][121].."!@C")
			end
			return false
		end
	else
		msg2(pl,"255000000"..string.format(lang[language[pl]][120], player(killwho[pl],"name")).."@C")
		return true
	end
end

function npc.checkxyspec(pl,x,y)
	for id = 1,npc.n do
		if npc[id] then
			local a = npc[id]
			if math.sqrt(a.x - player(pl,"x"),a.y - player(pl,"y")) < 75 then
				if hnpc[pl] == false then
					a.menu = 1
					hnpc[pl] = true
					if a.special == 0 then
						menu(pl,[[NPC ID: ]]..id..[[,]]..lang[language[pl]][98])
					elseif a.special == 1 then
						if hitman.rob[1] == true then
							if hitman.rob[2] == pl or hitman.rob[3] == pl or hitman.rob[4] == pl or hitman.rob[5] == pl then
								menu(pl,[[NPC ID: ]]..id..[[,]]..lang[language[pl]][100]..[[ ]]..bank[pl]..[[$]]..[[,]]..lang[language[pl]][116])
							else
								menu(pl,[[NPC ID: ]]..id..[[,]]..lang[language[pl]][100]..[[ ]]..bank[pl]..[[$]])
							end
						else
							menu(pl,[[NPC ID: ]]..id..[[,]]..lang[language[pl]][100]..[[ ]]..bank[pl]..[[$]])
						end
					elseif a.special == 2 then
						hitlang(pl)
						menu(pl,[[NPC ID: ]]..id..[[@b,]]..lang[language[pl]][104]..[[ ]]..hitman.m[1][pl][2]..[[,]]..lang[language[pl]][105]..[[ ]]..hitman.m[2][pl][2]..[[,]]..lang[language[pl]][106]..[[ ]]..hitman.m[3][pl][2]..[[,]]..lang[language[pl]][107]..[[ ]]..hitman.m[4][pl][2]..[[,]]..lang[language[pl]][108]..[[ ]]..hitman.m[5][pl][2])
					elseif a.special == 3 then
						menu(pl,[[NPC ID: ]]..id..[[,]]..lang[language[pl]][112]..[[|$25]])
					elseif a.special == 4 then
						a.menu = 0
						hnpc[pl] = false
						while kwoo(pl) == false do
							kwoo(pl)
						end
					elseif a.special == 5 then
						local k,b = zones.check((a.ttx-(a.ttx%32))/32,(a.tty-(a.tty%32))/32)
						if not b then b = "" end
						b = lang[language[pl]][139].." "..b
						if b == lang[language[pl]][139].." " then b = "" end
						menu(pl,[[NPC ID: ]]..id..[[,]]..lang[language[pl]][125]..[[,]]..lang[language[pl]][126]..[[|$]]..a.tprc..[[,]]..lang[language[pl]][127]..[[,]]..b)
					elseif a.special == 6 then
						msg2(pl,a.txt)
						a.menu = 0
						hnpc[pl] = false
					elseif a.special == 7 then
						menu(pl,[[NPC ID: ]]..id..[[,]]..a.bn)
					elseif a.special == 8 then
						if a.pa == false then
							for i = 1, #a.ximg do freeimage(a.ximg[i]) end
							a.ximg = {}
							a.field = { "", "", "",
										"", "", "",
										"", "", "" }
							a.p1 = pl
							if #player(0,"table") == 1 then
								msg2(pl,"255000000"..lang[language[pl]][121].."!@C")
							else
								while a.p2 == a.p1 or a.p2 == nil do
									a.p2 = player(0, "table")[math.random(1, #player(0,"table"))]
								end
								if a.p1 and a.p2 ~= a.p1 and a.p2 then
									a.p1p = { player(a.p1, "x"), player(a.p1, "y") }
									a.p2p = { player(a.p2, "x"), player(a.p2, "y") }
									setpos(a.p1, a.x, a.y)
									setpos(a.p2, a.x, a.y)
									a.r = a.p1
									msg2(a.p1,"000255000"..string.format(lang[language[a.p1]][141], player(a.p2,"name")))
									msg2(a.p2,"000255000"..string.format(lang[language[a.p2]][141], player(a.p1,"name")))
									a.pa = true
								end
							end
						end
						hnpc[pl] = false
						a.menu = 0
					end
				end
			end
		end
	end
end

function menu(id,txt,bla)
	if not bla then bla = 0 end
	if bla ~= 0 then
		if player(id,"health") > 0 then
			_menu(id,txt)
		else
			msg2(id,"255000000"..lang[language[id]][1].."@C")
		end
	else
		_menu(id,txt)
	end
end

function setpos(id,x,y,tile)
	if not id then return nil end
	if not x then return nil end
	if not y then return nil end
	if not tile then tile = 0 end
	if x > 0 and y > 0 and y < map("ysize") * 32 and x < map("xsize") * 32 then
		if tile == 0 then
			parse([[setpos ]]..id..[[ ]]..x..[[ ]]..y)
		else
			x = x * 32 + 16
			y = y * 32 + 16
			parse([[setpos ]]..id..[[ ]]..x..[[ ]]..y)
		end
	end
end

function isAdmin(id,tablee)
	if id == 0 then
		return false
	end
	if not tablee then tablee = adminList end
	for _,usgn in ipairs(tablee) do
		if player(id,"usgn") == usgn then
			return true
		end
	end
	return false
end

function hudtxt(i,txt,x,y,algin)
	if not algin then algin = 0 end
	parse([[hudtxt ]]..i..[[ "]]..txt..[[" ]]..x..[[ ]]..y..[[ ]]..algin)
end

function hudtxt2(id,i,txt,x,y,algin)
	if not algin then algin = 0 end
	parse([[hudtxt2 ]]..id..[[ ]]..i..[[ "]]..txt..[[" ]]..x..[[ ]]..y..[[ ]]..algin)
end

function updatehud(id)
	if not language[id] or language[id] == "" then language[id] = default_lang end
	hudtxt2(id,1,"060179113"..lang[language[id]][2].." "..money[id].."$",10,420,0)
	local z = select(2,zones.check(player(id,"tilex"),player(id,"tiley")))
	if z then
		hudtxt2(id,3,"205102029"..z,290,410,0)
	else
		hudtxt2(id,3,"",290,410,0)
	end
end

function save()
	for _,id in ipairs(player(0,"table")) do
		saveslf(id)
	end
end

function saveslf(id)
	local usgn = player(id,"usgn")
	if usgn > 0 then
		local f = false
		local p = ""
		local t = usgn..":"..money[id]..":"..bank[id]..":"..tostring(hitman.m[1][id][1])..":"..tostring(hitman.m[2][id][1])..":"..tostring(hitman.m[3][id][1])..":"..tostring(hitman.m[4][id][1])..":"..tostring(hitman.m[5][id][1])..":"..tostring(vip[id])..":"..player(id,"name").."\n"
		for lines in io.lines(save_file_path) do
			local line = toTable(lines, ":")
			if tonumber(line[1]) == usgn then
				p = p .. t
				f = true
			else
				p = p .. lines .. "\n"
			end
		end
		if f == true then
			local file = io.open(save_file_path,"w")
			file:write(p)
			file:close()
		else
			local file = io.open(save_file_path,"a")
			file:write(t)
			file:close()
		end
	end
end

function load()
	for _,id in ipairs(player(0,"table")) do
		loadslf(id)
	end
end

function loadslf(id)
	local usgn = player(id,"usgn")
	if usgn > 0 then
		for lines in io.lines(save_file_path) do
			local line = toTable(lines, ":")
			if tonumber(line[1]) == usgn then
				money[id] = tonumber(line[2])
				bank[id] = tonumber(line[3])
				hitman.m[1][id][1] = toboolean(line[4])
				hitman.m[2][id][1] = toboolean(line[5])
				hitman.m[3][id][1] = toboolean(line[6])
				hitman.m[4][id][1] = toboolean(line[7])
				hitman.m[5][id][1] = toboolean(line[8])
				vip[id] = toboolean(line[9])
			end
		end
	end
end

function reloadcfg(id)
	local old = language[id]
	free_all_images()
	lang = {}
	languages = ""
	default_lang = ""
	languages2 = {}
	admin_anonym_join = false
	autospecbots = false
	freeb = false
	spawn_protect_time = 3
	SuperAdmins = {}
	adminList = {}
	VIPList = {}
	plant.n = 0
	roof.n = 0
	npc.n = 0
	train.n = 0
	house.n = 0
	zones.n = 0
	dsfile(map_config_path)
	ddfile(languages_path)
	dafile(admin_file_path)
	for _,pl in ipairs(player(0,"table")) do
		language[pl] = default_lang
		hnpc[pl] = false
		do
			local id = pl
			for i,v in ipairs(hitman.rob) do
				if v == id then
					hitman.rob[i] = 0
				end
			end
			for _,pl in ipairs(player(0,"table")) do
				if pl ~= id then
					if car.gi[pl] == id then
						car.gi[pl] = 0
					elseif car.gi[id] == pl then
						car.gi[id] = 0
						parse([[speedmod ]]..pl..[[ 0]])
					end
				end
			end
			for i = 1,house.n do
				if house[i] then
					if id == house[i].owner then
						house[i].owner = 0
						if entity(house[i].dx,house[i].dy,"state") == true then
							parse([[trigger ]]..house[i].dname)
						end
					end
				end
			end
		end
		for id = 1,train.n do
			if train[id] then
				if train[id].p1 == id then
					if speed[train[id].p1] then
						parse([[speedmod ]]..train[id].p1..[[ ]]..yspeed[train[id].p1])
					else
						parse([[speedmod ]]..train[id].p1..[[ 0]])
					end
					train[id].p1 = 0
				elseif train[id].p2 == id then
					if speed[train[id].p2] then
						parse([[speedmod ]]..train[id].p2..[[ ]]..yspeed[train[id].p2])
					else
						parse([[speedmod ]]..train[id].p2..[[ 0]])
					end
					train[id].p2 = 0
				elseif train[id].p3 == id then
					if speed[train[id].p1] then
						parse([[speedmod ]]..train[id].p3..[[ ]]..yspeed[train[id].p3])
					else
						parse([[speedmod ]]..train[id].p3..[[ 0]])
					end
					train[id].p3 = 0
				elseif train[id].p4 == id then
					if speed[train[id].p1] then
						parse([[speedmod ]]..train[id].p4..[[ ]]..yspeed[train[id].p4])
					else
						parse([[speedmod ]]..train[id].p4..[[ 0]])
					end
					train[id].p4 = 0
				end
			end
		end
		updatehud(pl)
	end
	txtyst()
	first_time_id = 0
	first_time_map = false
	language[id] = old
end

function nom(id)
	msg2(id,"255000000"..lang[language[id]][3].."@C")
end

function table.find2(tbl,tbl2,val,val2)
	for i,v in ipairs(tbl) do
		for l,k in ipairs(tbl2) do
			if v == val and k == val2 and i == l then
				return true
			end
		end
	end
	return false
end

function checkxy(x,y)
	for id = 1,plant.n do
		if plant[id] then
			if plant[id].x == x and plant[id].y == y then
				return true
			end
		end
	end
	return false
end

function new_plant(x,y,ss)
	if not ss then ss = 0 end
	if table.find2(plant.area.x,plant.area.y,x,y) == true then
		if checkxy(x,y) == false then
			local img = plant.img
			plant.n = plant.n + 1
			local id = plant.n
			plant[id] = {
				x = x,
				y = y,
				img = image(img,x * 32 + 16,y * 32 + 16,0),
				mode = 1,
				super_plant = ss,
			}
		else
			return false
		end
	else
		return false
	end
end

function menue(id)
	local mon = money[id]
	menu(id,[[Drop Menu@b,100$,500$,1000$,2000$,5000$,10000$,50000$,100000$,]]..lang[language[id]][140],1)
end

function langsel(id)
	local langs = toTable(languages,",")
	if #langs > 8 then
		menu(id,[[Language,]]..langs[1]..[[,]]..langs[2]..[[,]]..langs[3]..[[,]]..langs[4]..[[,]]..langs[5]..[[,]]..langs[6]..[[,]]..langs[7]..[[,]]..langs[8]..[[,]]..lang[language[id]][122])
	else
		menu(id,[[Language,]]..languages)
	end
end

function equip(id,...)
	if id == 0 then
		for _,i in ipairs(player(0,"table")) do
			for wpn = 1,#arg do
				parse([[equip ]]..i..[[ ]]..arg[wpn])
			end
		end
	else
		for wpn = 1,#arg do
			parse([[equip ]]..id..[[ ]]..arg[wpn])
		end
	end
end

function spawnobject(bid,x,y,rot,mode,team,id)
	if not id then id = "" end
	if not team then team = 3 end
	if not mode then mode = 0 end
	if not rot then rot = 0 end
	parse([[spawnobject ]]..bid..[[ ]]..x..[[ ]]..y..[[ ]]..rot..[[ ]]..mode..[[ ]]..team..[[ ]]..id)
end

function b_names()
	for id = 1,32 do
		if player(id,"exists") then
			if player(id,"name"):sub(1,1) == "|" then
				pln[id] = player(id,"name"):sub(2)
			else
				pln[id] = player(id,"name")
			end
		else
			pln[id] = ""
		end
	end
end

function t_menu(id)
	if license[id] == true then
		menu(id,[[T Menu,]]..lang[language[id]][6]..[[,]]..lang[language[id]][136])
	else
		menu(id,[[T Menu,]]..lang[language[id]][7]..[[,]]..lang[language[id]][136])
	end
end

function ct_menu(id)
	if hasright(id,"z") or hasright(id,"s") then
		menu(id,[[CT Menu,]]..lang[language[id]][8]..[[,]]..lang[language[id]][136]..[[,]]..lang[language[id]][133])
	else
		menu(id,[[CT Menu,]]..lang[language[id]][8]..[[,]]..lang[language[id]][136])
	end
end

function tele_menu(id)
	if license[id] == true then
		if player(id,"team") == 2 then
			menu(id,[[Teleport-Menu@b,]]..lang[language[id]][9]..[[|$5000,]]..lang[language[id]][10]..[[,]]..lang[language[id]][11]..[[(]]..tostring(tsb[id])..[[),]]..lang[language[id]][12]..[[|X: (]]..math.ceil(arrest.x[id] / 32)..[[) Y: (]]..math.ceil(arrest.y[id] / 32)..[[)]],1)
		else
			menu(id,[[Teleport-Menu@b,]]..lang[language[id]][9]..[[|$5000,]]..lang[language[id]][10]..[[,]]..lang[language[id]][11]..[[(]]..tostring(tsb[id])..[[)]],1)
		end
	else
		msg2(id,"255000000"..lang[language[id]][42].."!@C")
	end
end

function systems(id)
	menu(id,[[Systems,]]..lang[language[id]][13]..[[,]]..lang[language[id]][14])
end

function help_men(id)
	menu(id,[[Help,Credits:,Yasday|Script,Unrealsoftware|CS2D,RedFrix|Ideas,Klin|Train Image,,,,]]..lang[language[id]][15])
end

function pc_1(id)
	b_names()
	menu(id,[[Players 1,]]..pln[1]..[[,]]..pln[2]..[[,]]..pln[3]..[[,]]..pln[4]..[[,]]..pln[5]..[[,]]..pln[6]..[[,]]..pln[7]..[[,]]..lang[language[id]][14]..[[,]]..lang[language[id]][17])
end

function pc_2(id)
	b_names()
	menu(id,[[Players 2,]]..pln[8]..[[,]]..pln[9]..[[,]]..pln[10]..[[,]]..pln[11]..[[,]]..pln[12]..[[,]]..pln[13]..[[,]]..pln[14]..[[,]]..lang[language[id]][16]..[[,]]..lang[language[id]][17])
end

function pc_3(id)
	b_names()
	menu(id,[[Players 3,]]..pln[15]..[[,]]..pln[16]..[[,]]..pln[17]..[[,]]..pln[18]..[[,]]..pln[19]..[[,]]..pln[20]..[[,]]..pln[21]..[[,]]..lang[language[id]][16]..[[,]]..lang[language[id]][17])
end

function pc_4(id)
	b_names()
	menu(id,[[Players 4,]]..pln[22]..[[,]]..pln[23]..[[,]]..pln[24]..[[,]]..pln[25]..[[,]]..pln[26]..[[,]]..pln[27]..[[,]]..pln[28]..[[,]]..lang[language[id]][16]..[[,]]..lang[language[id]][17])
end

function pc_5(id)
	b_names()
	menu(id,[[Players 5,]]..pln[29]..[[,]]..pln[30]..[[,]]..pln[31]..[[,]]..pln[32]..[[,,,,]]..lang[language[id]][16])
end

function nhitmans()
	local n = 0
	local tbl = {}
	for _,pl in ipairs(player(0,"table")) do
		if hitman[pl] == true then
			n = n + 1
			tbl[n] = pl
		end
	end
	return {n,tbl}
end

function write_auto(v)
	local f = io.open("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt","a")
	f:write(v.."\n")
	f:close()
end

function file_lenght(f)
	local b = 0
	for lines in io.lines(f) do
		b = b + 1
	end
	return b
end

function do_in(m,v)
	timer(m,"loadstring",v)
end

function train_config(id)
	local t = ""
	local t2 = ""
	if hstt == true then
		t = "on"
	else
		t = "off"
	end
	if hsttt == true then
		t2 = "on"
	else
		t2 = "off"
	end
	menu(id,[[Train Config@b,Set Pos,Undo last,Ticket ]]..t..[[,Rails ]]..t2..[[,Current: ]]..[[{]]..is0[1]..[[;]]..is0[2]..[[;]]..is0[3]..[[}-]]..[[{]]..is1[1]..[[;]]..is1[2]..[[;]]..is1[3]..[[}-]]..[[{]]..is2[1]..[[;]]..is2[2]..[[;]]..is2[3]..[[}-]]..[[{]]..is3[1]..[[;]]..is3[2]..[[;]]..is3[3]..[[}-]]..[[{]]..is4[1]..[[;]]..is4[2]..[[;]]..is4[3]..[[},               ]]..[[{]]..is5[1]..[[;]]..is5[2]..[[;]]..is5[3]..[[}-]]..[[{]]..is6[1]..[[;]]..is6[2]..[[;]]..is6[3]..[[}-]]..[[{]]..is7[1]..[[;]]..is7[2]..[[;]]..is7[3]..[[}-]]..[[{]]..is8[1]..[[;]]..is8[2]..[[;]]..is8[3]..[[}-]]..[[{]]..is9[1]..[[;]]..is9[2]..[[;]]..is9[3]..[[},Set trainrail image for all trains,Set traibn iage,Create train]])
end

function npc_add_n(id)
	menu(id,[[Add NPC,Set position and rotation,Set mode,Set special,Set image,Create]])
end

function npc_add_t(id)
	menu(id,[[Add teleport NPC,Set position and rotation,Set teleport position,Set mode,Set price,Set image,Create]])
end

function npc_add_s(id)
	menu(id,[[Add "say" NPC,Set position and rotation,Set mode,Set what the NPC says,Set color,Set image,Create]])
end

function car.gi_c(pl)
	for _,id in ipairs(player(0,"table")) do
		if pl ~= id and pl ~= 0 then
			if car[id] == true then
				if math.sqrt((player(pl,"tilex") - car.tx[id]),(player(pl,"tiley") - car.ty[id])) < 2 then
					if car.gi[id] == 0 then
						car.gi[id] = pl
						parse([[speedmod ]]..pl..[[ -100]])
						return 1
					end
				end
				if car.gi[id] == pl then
					car.gi[id] = 0
					if speed[pl] then
						parse([[speedmod ]]..pl..[[ ]]..yspeed[pl])
					else
						parse([[speedmod ]]..pl..[[ 0]])
					end
				end
			end
		end
	end
end

function car.is_c(pl)
	if math.sqrt((player(pl,"tilex") - car.tx[pl]),(player(pl,"tiley") - car.ty[pl])) < 2 then
		if car[pl] == true then
			if car.is[pl] == false then
				car.is[pl] = true
				freeimage(car.img[pl])
				car.img[pl] = image(car_image,1,1,pl + 132)
				car.x[pl] = player(pl,"x")
				car.y[pl] = player(pl,"y")
				car.sp[pl] = 1
				car.bla[pl] = 0
			else
				car.is[pl] = false
				freeimage(car.img[pl])
				car.img[pl] = image(car_image,player(pl,"x"),player(pl,"y"),3)
				car.x[pl] = player(pl,"x")
				car.y[pl] = player(pl,"y")
				imagepos(car.img[pl],car.x[pl],car.y[pl],player(pl,"rot"))
				car.tx[pl] = player(pl,"tilex")
				car.ty[pl] = player(pl,"tiley")
				car.sp[pl] = 1
				car.bla[pl] = 0
			end
		end
	end
end

function car.destroy(id)
	car[id] = false
	car.is[id] = false
	freeimage(car.img[id])
	car.img[id] = -1
	car.x[id] = -100
	car.y[id] = -100
	car.tx[id] = -100
	car.ty[id] = -100
	car.sp[id] = 1
	car.bla[id] = 0
end

function car_change(id)
	if car[id] == false then
		if not car.is[id] then
			if money[id] >= 50000 then
				money[id] = money[id] - 50000
				updatehud(id)
				car[id] = true
				msg2(id,"000255000"..lang[language[id]][48].."@C")
				car.is[id] = true
				freeimage(car.img[id])
				car.img[id] = image(car_image,1,1,id + 132)
				car.x[id] = player(id,"x")
				car.y[id] = player(id,"y")
				car.sp[id] = 1
				car.bla[id] = 0
			else
				nom(id)
			end
		end
	else
		car.is_c(pl)
	end
end

function train.use_c(pl)
	for id = 1,train.n do
		if train[id] then
			if math.sqrt(player(pl,"x") - train[id].x,player(pl,"y") - train[id].y) < 75 then
				if train[id].tr == false then
					if not intrain(pl) then
						if train[id].ticket == true then
							if train.ticket[pl] == true then
								if train[id].p1 == 0 then
									train[id].p1 = pl
									parse([[speedmod ]]..pl..[[ -100]])
									setpos(pl,train[id].x,train[id].y)
								elseif train[id].p2 == 0 then
									train[id].p2 = pl
									parse([[speedmod ]]..pl..[[ -100]])
									setpos(pl,train[id].x,train[id].y)
								elseif train[id].p3 == 0 then
									train[id].p3 = pl
									parse([[speedmod ]]..pl..[[ -100]])
									setpos(pl,train[id].x,train[id].y)
								elseif train[id].p4 == 0 then
									train[id].p4 = pl
									parse([[speedmod ]]..pl..[[ -100]])
									setpos(pl,train[id].x,train[id].y)
								end
								msg2(pl,"255255255"..lang[language[pl]][110])
								train.ticket[pl] = false
							else
								msg2(pl,"255000000"..lang[language[pl]][111])
							end
							return
						else
							if train[id].p1 == 0 then
								train[id].p1 = pl
								parse([[speedmod ]]..pl..[[ -100]])
								setpos(pl,train[id].x,train[id].y)
							elseif train[id].p2 == 0 then
								train[id].p2 = pl
								parse([[speedmod ]]..pl..[[ -100]])
								setpos(pl,train[id].x,train[id].y)
							elseif train[id].p3 == 0 then
								train[id].p3 = pl
								parse([[speedmod ]]..pl..[[ -100]])
								setpos(pl,train[id].x,train[id].y)
							elseif train[id].p4 == 0 then
								train[id].p4 = pl
								parse([[speedmod ]]..pl..[[ -100]])
								setpos(pl,train[id].x,train[id].y)
							end
							return
						end
					end
				end
			end
		end
	end
end

function npc_add_e(id)
	menu(id,[[Add sell NPC,Set position and rotation,Set mode,Set weapons and prices|]]..has_w_n..[[,Undo last,Set image,Create]])
end

function weapon_menu(id)
	menu(id,[[Weapons Page ]]..(rpage[id] + 1)..[[,]]..weapons_n[page[id] + 1]..[[,]]..weapons_n[page[id] + 2]..[[,]]..weapons_n[page[id] + 3]..[[,]]..weapons_n[page[id] + 4]..[[,]]..weapons_n[page[id] + 5]..[[,]]..weapons_n[page[id] + 6]..[[,]]..weapons_n[page[id] + 7]..[[,Previous,Next]])
end

function timehud()
	for _,pl in ipairs(player(0,"table")) do
		if sec >= 10 and h >= 10 then
			hudtxt2(pl,2,"072118255"..lang[language[pl]][124]..": "..h..":"..sec,290,440,0)
		elseif sec >= 10 and h < 10 then
			hudtxt2(pl,2,"072118255"..lang[language[pl]][124]..": 0"..h..":"..sec,290,440,0)
		elseif sec < 10 and h >= 10 then
			hudtxt2(pl,2,"072118255"..lang[language[pl]][124]..": "..h..":0"..sec,290,440,0)
		elseif sec < 10 and h < 10 then
			hudtxt2(pl,2,"072118255"..lang[language[pl]][124]..": 0"..h..":0"..sec,290,440,0)
		end
	end
end

function buildingmoney(types)
	local mon = 0
	if types == 1 then
		mon = 300
	elseif types == 2 then
		mon = 500
	elseif types == 3 then
		mon = 1000
	elseif types == 4 then
		mon = 2000
	elseif types == 5 then
		mon = 3000
	elseif types == 6 then
		mon = 1500
	elseif types == 7 then
		mon = 5000
	elseif types == 8 then
		mon = 5000
	elseif types == 9 then
		mon = 5000
	elseif types == 13 then
		mon = 3000
	elseif types == 14 then
		mon = 3000
	end
	return mon
end

function zones.check(x,y)
	for id = 1,zones.n,1 do
		if zones[id] then
			if x >= zones[id].x[1] and x <= zones[id].x[2] and y >= zones[id].y[1] and y <= zones[id].y[2] then
				return true,zones[id].name
			end
		end
	end
	return false
end

function create_rails(id)
	local a = train[id]
	while a.didrails ~= true do
		if a then
			if a.tx == a.c1[1] and a.ty == a.c1[2] then
				a.rot = a.c1[3]
			end
			if a.ty == a.c2[2] and a.tx == a.c2[1] then
				a.rot = a.c2[3]
			end
			if a.ty == a.c3[2] and a.tx == a.c3[1] then
				a.rot = a.c3[3]
			end
			if a.ty == a.c4[2] and a.tx == a.c4[1] then
				a.rot = a.c4[3]
			end
			if a.ty == a.c5[2] and a.tx == a.c5[1] then
				a.rot = a.c5[3]
			end
			if a.ty == a.c6[2] and a.tx == a.c6[1] then
				a.rot = a.c6[3]
			end
			if a.ty == a.c7[2] and a.tx == a.c7[1] then
				a.rot = a.c7[3]
			end
			if a.ty == a.c8[2] and a.tx == a.c8[1] then
				a.rot = a.c8[3]
			end
			if a.ty == a.c9[2] and a.tx == a.c9[1] then
				a.rot = a.c9[3]
			end
			if a.ty == a.c10[2] and a.tx == a.c10[1] then
				a.sp = 0
				a.t = 0
				a.didrails = true
				a.rot = a.c10[3]
			end
			local c = image(train.railimage,0,0,0,0)
			imagepos(c, a.x, a.y, a.rot)
			imagealpha(c, 1)
			imagecolor(c, 255, 255, 255)
			imageblend(c, 2)
			imagescale(c, 1, 1)
			table.insert(a.railimgs,c)
			a.x = a.x + math.sin(math.rad(a.rot)) * 32
			a.y = a.y - math.cos(math.rad(a.rot)) * 32
			a.tx = math.ceil(a.x / 32) - 1
			a.ty = math.ceil(a.y / 32) - 1
		end
	end
	a.x = a.c1[1] * 32 + 16
	a.y = a.c1[2] * 32 + 16
	a.tx = math.ceil(a.x / 32) - 1
	a.ty = math.ceil(a.y / 32) - 1
end

--Hooks

function always_hook()
	for id = 1,train.n do
		if train[id] then
			if train[id].didrails == false and train[id].tsa == false then
				create_rails(id)
			elseif train[id].tsa == true then
				train[id].tsa = false
				train[id].didrails = true
				train[id].x = train[id].c1[1] * 32 + 16
				train[id].y = train[id].c1[2] * 32 + 16
				train[id].tx = math.ceil(train[id].x / 32) - 1
				train[id].ty = math.ceil(train[id].y / 32) - 1
			end
			local a = train[id]
			if a.tr == true then
				if a.back == false then
					if a.tx * 32 + 16 == a.c1[1] * 32 + 16 and a.ty * 32 + 16 == a.c1[2] * 32 + 16 then
						a.rot = a.c1[3]
					end
					if a.y == a.c2[2] * 32 + 16 and a.x == a.c2[1] * 32 + 16 then
						a.rot = a.c2[3]
					end
					if a.y == a.c3[2] * 32 + 16 and a.x == a.c3[1] * 32 + 16 then
						a.rot = a.c3[3]
					end
					if a.y == a.c4[2] * 32 + 16 and a.x == a.c4[1] * 32 + 16 then
						a.rot = a.c4[3]
					end
					if a.y == a.c5[2] * 32 + 16 and a.x == a.c5[1] * 32 + 16 then
						a.rot = a.c5[3]
					end
					if a.y == a.c6[2] * 32 + 16 and a.x == a.c6[1] * 32 + 16 then
						a.rot = a.c6[3]
					end
					if a.y == a.c7[2] * 32 + 16 and a.x == a.c7[1] * 32 + 16 then
						a.rot = a.c7[3]
					end
					if a.y == a.c8[2] * 32 + 16 and a.x == a.c8[1] * 32 + 16 then
						a.rot = a.c8[3]
					end
					if a.y == a.c9[2] * 32 + 16 and a.x == a.c9[1] * 32 + 16 then
						a.rot = a.c9[3]
					end
					if a.y == a.c10[2] * 32 + 16 and a.x == a.c10[1] * 32 + 16 then
						a.sp = 0
						a.tr = false
						a.t = 0
						a.back = true
						a.rot = a.c10[3]
						if a.p1 ~= 0 then
							if speed[a.p1] then
								parse([[speedmod ]]..a.p1..[[ ]]..yspeed[a.p1])
							else
								parse([[speedmod ]]..a.p1..[[ 0]])
							end
							a.p1 = 0
						end
						if a.p2 ~= 0 then
							if speed[a.p2] then
								parse([[speedmod ]]..a.p2..[[ ]]..yspeed[a.p2])
							else
								parse([[speedmod ]]..a.p2..[[ 0]])
							end
							a.p2 = 0
						end
						if a.p3 ~= 0 then
							if speed[a.p3] then
								parse([[speedmod ]]..a.p3..[[ ]]..yspeed[a.p3])
							else
								parse([[speedmod ]]..a.p3..[[ 0]])
							end
							a.p3 = 0
						end
						if a.p4 ~= 0 then
							if speed[a.p4] then
								parse([[speedmod ]]..a.p4..[[ ]]..yspeed[a.p4])
							else
								parse([[speedmod ]]..a.p4..[[ 0]])
							end
							a.p4 = 0
						end
					end
				else
					if a.x == a.c10[1] * 32 + 16 and a.y == a.c10[2] * 32 + 16 then
						a.rot = a.c10[3]
					end
					if a.x == a.c9[1] * 32 + 16 and a.y == a.c9[2] * 32 + 16 then
						if a.c10[3] ~= a.c9[3] then
							if a.c8[3] == 90 then
								a.rot = 270
							elseif a.c8[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c9[3] - 270)
							end
						end
					end
					if a.x == a.c8[1] * 32 + 16 and a.y == a.c8[2] * 32 + 16 then
						if a.c9[3] ~= a.c8[3] then
							if a.c7[3] == 90 then
								a.rot = 270
							elseif a.c7[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c8[3] - 270)
							end
						end
					end
					if a.x == a.c7[1] * 32 + 16 and a.y == a.c7[2] * 32 + 16 then
						if a.c8[3] ~= a.c7[3] then
							if a.c6[3] == 90 then
								a.rot = 270
							elseif a.c6[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c7[3] - 270)
							end
						end
					end
					if a.x == a.c6[1] * 32 + 16 and a.y == a.c6[2] * 32 + 16 then
						if a.c7[3] ~= a.c6[3] then
							if a.c5[3] == 90 then
								a.rot = 270
							elseif a.c5[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c6[3] - 270)
							end
						end
					end
					if a.x == a.c5[1] * 32 + 16 and a.y == a.c5[2] * 32 + 16 then
						if a.c6[3] ~= a.c5[3] then
							if a.c4[3] == 90 then
								a.rot = 270
							elseif a.c4[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c5[3] - 270)
							end
						end
					end
					if a.x == a.c4[1] * 32 + 16 and a.y == a.c4[2] * 32 + 16 then
						if a.c5[3] ~= a.c4[3] then
							if a.c3[3] == 90 then
								a.rot = 270
							elseif a.c3[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c4[3] - 270)
							end
						end
					end
					if a.y == a.c3[2] * 32 + 16 and a.x == a.c3[1] * 32 + 16 then
						if a.c4[3] ~= a.c3[3] then
							if a.c2[3] == 90 then
								a.rot = 270
							elseif a.c2[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c3[3] - 270)
							end
						end
					end
					if a.y == a.c2[2] * 32 + 16 and a.x == a.c2[1] * 32 + 16 then
						if a.c3[3] ~= a.c2[3] then
							if a.c1[3] == 90 then
								a.rot = 270
							elseif a.c1[3] == 180 then
								a.rot = 0
							else
								a.rot = math.abs(a.c2[3] - 270)
							end
						end
					end
					if a.y == a.c1[2] * 32 + 16 and a.x == a.c1[1] * 32 + 16 then
						a.sp = 0
						a.tr = false
						a.t = 0
						a.back = false
						a.rot = a.c1[3]
						if a.p1 ~= 0 then
							if speed[a.p1] then
								parse([[speedmod ]]..a.p1..[[ ]]..yspeed[a.p1])
							else
								parse([[speedmod ]]..a.p1..[[ 0]])
							end
							a.p1 = 0
						end
						if a.p2 ~= 0 then
							if speed[a.p2] then
								parse([[speedmod ]]..a.p2..[[ ]]..yspeed[a.p2])
							else
								parse([[speedmod ]]..a.p2..[[ 0]])
							end
							a.p2 = 0
						end
						if a.p3 ~= 0 then
							if speed[a.p3] then
								parse([[speedmod ]]..a.p3..[[ ]]..yspeed[a.p3])
							else
								parse([[speedmod ]]..a.p3..[[ 0]])
							end
							a.p3 = 0
						end
						if a.p4 ~= 0 then
							if speed[a.p4] then
								parse([[speedmod ]]..a.p4..[[ ]]..yspeed[a.p4])
							else
								parse([[speedmod ]]..a.p4..[[ 0]])
							end
							a.p4 = 0
						end
					end
				end
				if a.t == 350 and a.x%16 == 0 and a.y%16 == 0 then
					if a.x%16 == 0 and a.y%16 == 0 then
						a.sp = 2
					else
						for i = 1,16 do
							do_in(i * 100,"local a = train["..id.."] if a.x%16 == 0 and a.y%16 == 0 then a.sp = 2 end")
						end
					end
				elseif a.t == 370 and a.x%16 == 0 and a.y%16 == 0 then

					if a.x%16 == 0 and a.y%16 == 0 then
						a.sp = 4
					else
						for i = 1,16 do
							do_in(i * 100,"local a = train["..id.."] if a.x%16 == 0 and a.y%16 == 0 then a.sp = 4 end")
						end
					end
				elseif a.t == 450 and a.x%16 == 0 and a.y%16 == 0 then
					if a.x%16 == 0 and a.y%16 == 0 then
						a.sp = 8
					else
						for i = 1,16 do
							do_in(i * 100,"local a = train["..id.."] if a.x%16 == 0 and a.y%16 == 0 then a.sp = 8 end")
						end
					end
				elseif a.t == 600 then
					if a.x%16 == 0 and a.y%16 == 0 then
						a.sp = 16
					else
						for i = 1,16 do
							do_in(i * 100,"local a = train["..id.."] if a.x%16 == 0 and a.y%16 == 0 then a.sp = 16 end")
						end
					end
				end
				a.x = a.x + math.sin(math.rad(a.rot)) * a.sp
				a.y = a.y - math.cos(math.rad(a.rot)) * a.sp
				a.tx = math.ceil(a.x / 32) - 1
				a.ty = math.ceil(a.y / 32) - 1
				for _,pl in ipairs(player(0,"table")) do
					if a.p1 ~= pl and a.p2 ~= pl and a.p3 ~= pl and a.p4 ~= pl then
						if player(pl,"tilex") == a.tx and player(pl,"tiley") == a.ty then
							if a.sp > 3 then
								parse([[customkill ]]..pl..[[ train ]]..pl)
							end
						end
					end
				end
				if a.p1 ~= 0 then
					setpos(a.p1,a.x,a.y)
				end
				if a.p2 ~= 0 then
					setpos(a.p2,a.x,a.y)
				end
				if a.p3 ~= 0 then
					setpos(a.p3,a.x,a.y)
				end
				if a.p4 ~= 0 then
					setpos(a.p4,a.x,a.y)
				end
				imagepos(a.img,a.x,a.y,a.rot)
			end
		end
	end
	for id = 1,npc.n do
		if npc[id] then
			if npc[id].mode == 1 then -- UP and DOWN
				if npc[id].times <= 500 then
					npc[id].rot = 0
					local x,y
					x = npc[id].x + math.sin(math.rad(npc[id].rot))
					y = npc[id].y - math.cos(math.rad(npc[id].rot))
					if tile(math.ceil(x / 32) - 1,math.ceil(y / 32) - 1,"walkable") then
						if npc[id].menu == 0 then
							npc[id].x = x
							npc[id].y = y
							npc[id].times = npc[id].times + 1
							if npc[id].ble[1] == false then
								if npc[id].ble[2] < 25 then
									npc[id].ble[2] = npc[id].ble[2] + 1
								else
									npc[id].ble[1] = true
								end
							end
							if npc[id].ble[1] == true then
								if npc[id].ble[2] > -25 then
									npc[id].ble[2] = npc[id].ble[2] - 1
								else
									npc[id].ble[1] = false
								end
							end
						end
					else
						npc[id].times = 501
					end
				elseif npc[id].times <= 1000 and npc[id].times > 500 then
					npc[id].rot = 180
					local x,y
					x = npc[id].x + math.sin(math.rad(npc[id].rot))
					y = npc[id].y - math.cos(math.rad(npc[id].rot))
					if tile(math.ceil(x / 32) - 1,math.ceil(y / 32) - 1,"walkable") then
						if npc[id].menu == 0 then
							npc[id].x = x
							npc[id].y = y
							npc[id].times = npc[id].times + 1
							if npc[id].ble[1] == false then
								if npc[id].ble[2] < 25 then
									npc[id].ble[2] = npc[id].ble[2] + 1
								else
									npc[id].ble[1] = true
								end
							end
							if npc[id].ble[1] == true then
								if npc[id].ble[2] > -25 then
									npc[id].ble[2] = npc[id].ble[2] - 1
								else
									npc[id].ble[1] = false
								end
							end
						end
					else
						npc[id].times = 0
					end
				end
				if npc[id].times > 1000 then
					npc[id].times = 0
				end
			elseif npc[id].mode == 2 then -- LEFT and RIGHT
				if npc[id].times <= 500 then
					npc[id].rot = 90
					local x,y
					x = npc[id].x + math.sin(math.rad(npc[id].rot))
					y = npc[id].y - math.cos(math.rad(npc[id].rot))
					if tile(math.ceil(x / 32) - 1,math.ceil(y / 32) - 1,"walkable") then
						if npc[id].menu == 0 then
							npc[id].x = x
							npc[id].y = y
							npc[id].times = npc[id].times + 1
							if npc[id].ble[1] == false then
								if npc[id].ble[2] < 25 then
									npc[id].ble[2] = npc[id].ble[2] + 1
								else
									npc[id].ble[1] = true
								end
							end
							if npc[id].ble[1] == true then
								if npc[id].ble[2] > -25 then
									npc[id].ble[2] = npc[id].ble[2] - 1
								else
									npc[id].ble[1] = false
								end
							end
						end
					else
						npc[id].times = 501
					end
				elseif npc[id].times <= 1000 and npc[id].times > 500 then
					npc[id].rot = 270
					local x,y
					x = npc[id].x + math.sin(math.rad(npc[id].rot))
					y = npc[id].y - math.cos(math.rad(npc[id].rot))
					if tile(math.ceil(x / 32) - 1,math.ceil(y / 32) - 1,"walkable") then
						if npc[id].menu == 0 then
							npc[id].x = x
							npc[id].y = y
							npc[id].times = npc[id].times + 1
							if npc[id].ble[1] == false then
								if npc[id].ble[2] < 25 then
									npc[id].ble[2] = npc[id].ble[2] + 1
								else
									npc[id].ble[1] = true
								end
							end
							if npc[id].ble[1] == true then
								if npc[id].ble[2] > (0 - 25) then
									npc[id].ble[2] = npc[id].ble[2] - 1
								else
									npc[id].ble[1] = false
								end
							end
						end
					else
						npc[id].times = 0
					end
				end
				if npc[id].times > 1000 then
					npc[id].times = 0
				end
			end
			imagepos(npc[id].img,npc[id].x,npc[id].y,npc[id].rot + npc[id].ble[2])
		end
	end
	for id = 1,roof.n do
		for _,pl in ipairs(player(0,"table")) do
			if math.sqrt(player(pl,"x") - roof[id][pl].x,player(pl,"y") - roof[id][pl].y) < roof[id][pl].w then
				if roof[id][pl].img ~= 0 then
					freeimage(roof[id][pl].img)
					roof[id][pl].img = 0
				end
			else
				if roof[id][pl].img == 0 then
					roof[id][pl].img = 1
					roof[id][pl].img = image(roof[id][pl].oimg,roof[id][pl].x,roof[id][pl].y,3,pl)
				end
			end
		end
	end
	for _,id in ipairs(player(0,"table")) do
		if car[id] == true then
			if car.is[id] == true then
				if car.sp[id] < 7 then
					if car.bla[id] == 25 then
						car.sp[id] = 2
					elseif car.bla[id] == 100 then
						car.sp[id] = 3
					elseif car.bla[id] == 200 then
						car.sp[id] = 4
					elseif car.bla[id] == 300 then
						car.sp[id] = 5
					elseif car.bla[id] == 400 then
						car.sp[id] = 6
					elseif car.bla[id] == 600 then
						car.sp[id] = 7
						car.bla[id] = 0
					end
					car.bla[id] = car.bla[id] + 1
				end
				local x,y,rot = car.x[id],car.y[id],player(id,"rot")
				x = x + math.sin(math.rad(rot)) * car.sp[id]
				y = y - math.cos(math.rad(rot)) * car.sp[id]
				local pl = car.gi[id]
				if pl ~= 0 then
					local x,y,rot = car.x[id],car.y[id],player(pl,"rot")
					x = x + math.sin(math.rad(rot)) * car.sp[id]
					y = y - math.cos(math.rad(rot)) * car.sp[id]
					if tile(math.ceil(x / 32) - 1,math.ceil(y / 32) - 1,"walkable") then
						setpos(pl,x,y)
					end
				end
				if tile(math.ceil(x / 32) - 1,math.ceil(y / 32) - 1,"walkable") then
					setpos(id,x,y)
					car.x[id] = x
					car.y[id] = y
				else
					car.sp[id] = 1
					car.bla[id] = 0
				end
				car.tx[id] = player(id,"tilex")
				car.ty[id] = player(id,"tiley")
				for _,pl in ipairs(player(0,"table")) do
					if pl ~= id then
						if pl ~= car.gi[id] then
							if car[pl] and car.is[pl] then
								if math.sqrt((car.tx[pl] - car.tx[id]),(car.ty[pl] - car.ty[id])) < 2 then
									if car.sp[id] >= 4 or car.sp[pl] >= 4 then
										parse("explosion "..car.tx[pl] * 32 + (16).." "..car.ty[pl] * 32 + (16).." 64 0")
										parse("explosion "..car.tx[id] * 32 + (16).." "..car.ty[id] * 32 + (16).." 64 0")
										parse("sethealth "..pl.." "..player(pl,"health") - 75)
										parse("sethealth "..id.." "..player(id,"health") - 75)
										for _, i in ipairs(player(0,"table")) do
											if car.gi[id] == i then
												car.gi[id] = 0
												if speed[i] then
													parse([[speedmod ]]..i..[[ ]]..yspeed[i])
												else
													parse([[speedmod ]]..i..[[ 0]])
												end
											elseif car.gi[pl] == i then
												car.gi[pl] = 0
												if speed[i] then
													parse([[speedmod ]]..i..[[ ]]..yspeed[i])
												else
													parse([[speedmod ]]..i..[[ 0]])
												end
											end
										end
										car.destroy(pl)
										car.destroy(id)
									else
										car.sp[id] = 2
										car.sp[pl] = 2
										car.bla[id] = 200
										car.bla[id] = 300
									end
								end
							end
							if math.sqrt((player(pl,"tilex") - car.tx[id]),(player(pl,"tiley") - car.ty[id])) < 2 then
								if spawnprotect[pl] == false then
									if car.kills[id] < 100 then
										if car.sp[id] > 3 then
											if admk[pl] == false and not car.is[pl] then
												parse([[customkill ]]..id..[[ car ]]..pl)
												car.kills[id] = car.kills[id] + 1
											end
										end
									else
										msg2(id,"255000000"..lang[language[id]][96].."@C")
										car.sp[id] = 2
										car.bla[id] = 0
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function attack_hook(id)
	local wpn = player(id,"weapontype")
	if hasright(id, "z") or hasright(id, "w") then
		parse([[equip ]]..id..[[ ]]..wpn)
		parse([[setweapon ]]..id..[[ ]]..wpn)
		if wpn == 69 then
			local x,y,rot = player(id,"x"),player(id,"y"),player(id,"rot")
			x = x + math.sin(math.rad(rot)) * 100
			y = y - math.cos(math.rad(rot)) * 100
			parse([[explosion ]]..x..[[ ]]..y..[[ 25 100000000 ]]..id)
		end
	end
end

function buildattempt_hook(id,type,x,y)
	local rot = player(id,"rot")
	local team = player(id,"team")
	if hasright(id, "z") or hasright(id, "f") then
		if type == 8 then
			if blv[1][id] == 2 then type = 11 end
			if blv[1][id] == 3 then type = 12 end
		end
		if type == 9 then
			if blv[2][id] == 2 then type = 15 end
		end
		if bcol[id] == 1 then
			local m = buildingmoney(type)
			if money[id] >= m then
				money[id] = money[id] - m
				updatehud(id)
				spawnobject(type,x,y,rot,mode,2,id)
			else
				nom(id)
			end
		elseif bcol[id] == 2 then
			local m = buildingmoney(type)
			if money[id] >= m then
				money[id] = money[id] - m
				updatehud(id)
				spawnobject(type,x,y,rot,mode,1,id)
			else
				nom(id)
			end
		elseif bcol[id] == 3 then
			local m = buildingmoney(type)
			if money[id] >= m then
				money[id] = money[id] - m
				updatehud(id)
				spawnobject(type,x,y,rot,mode,0,id)
			else
				nom(id)
			end
		elseif bcol[id] == 4 then
			local m = buildingmoney(type)
			if money[id] >= m then
				money[id] = money[id] - m
				updatehud(id)
				spawnobject(type,x,y,rot,mode,3,id)
			else
				nom(id)
			end
		end
		return 1
	else
		if freeb == false then
			if license[id] ~= true then
				msg2(id,"255000000"..lang[language[id]][42].."!@C")
				return 1
			else
				local m = buildingmoney(type)
				if money[id] >= m then
					money[id] = money[id] - m
					updatehud(id)
					spawnobject(type,x,y,rot,mode,team,id)
				else
					nom(id)
				end
				return 1
			end
		else
			local m = buildingmoney(type)
			if money[id] >= m then
				money[id] = money[id] - m
				updatehud(id)
				spawnobject(type,x,y,rot,mode,team,id)
			else
				nom(id)
			end
			return 1
		end
	end
end

function die_hook(id, killer, weapon, x, y)
	if hasright(id, "z") or hasright(id, "d") then
		if tile(player(id,"tilex"), player(id,"tiley"), "walkable") then
			die_x[id] = player(id, "x")
			die_y[id] = player(id, "y")
			parse("setdeaths "..id.." "..player(id,"deaths") - 1)
		end
	end
	if car.is[id] then
		car.is_c(id)
	end
end

function drop_hook(id, iid, type, ain, a, mode, x, y)
	if drop_spec[id] then
		drop_spec[id] = false
		return 2
	end
end

function hit_hook(id,src,wpn,hpdmg,wpndmg)
	if src == 0 and not hasright(id, "z") and not hasright(id,"x") then return end
	if hasright(id, "z") or hasright(id, "x") then
		return 1
	end
	if spawnprotect[id] == true then
		return 1
	end
	if car.gi[id] == src or car.gi[src] == id then
		return 1
	end
	for n = 1, train.n do
		if train[n] then
			if train[n].p1 == id or train[n].p2 == id or train[n].p3 == id or train[n].p4 == id then
				if train[n].p1 == src or train[n].p2 == src or train[n].p3 == src or train[n].p4 == src then
					return 1
				end
			end
		end
	end
	if wpn == 6 then
		if hasright(src, "z") or hasright(src, "a") then
			if arrest[id] == false then
				arrest[id] = true
				arrest.x.vic[id] = arrest.x[src]
				arrest.y.vic[id] = arrest.y[src]
				setpos(id,arrest.x.vic[id],arrest.y.vic[id])
			else
				arrest[id] = false
				setpos(id,tsx,tsy,1)
			end
			return 1
		end
	elseif wpn == 32 then
		if hasright(src, "z") or hasright(src, "w") then
			parse([[customkill ]]..src..[[ M4A1 ]]..id)
			return 1
		end
	elseif wpn == 45 then
		if not hasright(src,"z") and not hasright(src,"w") then
			parse([[sethealth ]]..id..[[ ]]..player(id,"health") + 45)
		end
		return 1
	end
end

function join_hook(id)
	if not language[id] then language[id] = default_lang end
	if id == first_time_id and first_time_map then
		msg2(id,[[000255000It's the first time you use this map, if you want to configurate it then press F2/F3@C]])
		return
	end
	loadslf(id)
	updatehud(id)
end

function kill_hook(src,id,wpn,x,y)
	if id == killwho[src] then
		killwho[src] = 0
		msg2(src,"000255000"..lang[language[src]][103].."!".." +500$@C")
		money[src] = money[src] + 500
		updatehud(src)
	end
	if src ~= id then
		if hitman.m[1][src][3] == true then
			if wpn == 3 then
				hitman.m[1][src][1] = true
				hitman.k[src].Deagle = 1
				hitman.m[1][src][3] = false
				hitman[src] = true
				msg2(src,"000255000"..lang[language[src]][103].."!".." +2000$")
				money[src] = money[src] + 2000
				updatehud(src)
			end
		end
		if hitman[src] == true then
			money[src] = money[src] + 100
			if hitman.m[2][src][3] == true then
				hitman.k[src][1] = hitman.k[src][1] + 1
				if hitman.k[src][1] >= 5 then
					msg2(src,"000255000"..lang[language[src]][103].."!".." +4000$")
					money[src] = money[src] + 4000
					updatehud(src)
					hitman.m[2][src][1] = true
					hitman.m[2][src][3] = false
				end
			end
			if hitman.m[4][src][3] == true then
				if wpn == 1 then
					hitman.k[src].USP = hitman.k[src].USP + 1
				end
				if hitman.k[src].USP >= 20 then
					msg2(src,"000255000"..lang[language[src]][103].."!".." +10000$")
					money[src] = money[src] + 10000
					updatehud(src)
					hitman.m[4][src][1] = true
					hitman.m[4][src][3] = false
				end
			end
			if hitman.m[5][src][3] == true then
				if hitman[id] == true then
					hitman.k[src].hitman = hitman.k[src].hitman + 1
				end
				if hitman.k[src].hitman >= 5 then
					msg2(src,"000255000"..lang[language[src]][103].."!".." +14000$")
					money[src] = money[src] + 14000
					updatehud(src)
					hitman.m[5][src][1] = true
					hitman.m[5][src][3] = false
				end
			end
		end
	end
	for _,pl in ipairs(player(0,"table")) do
		if pl ~= id then
			if car.gi[pl] == id then
				car.gi[pl] = 0
			elseif car.gi[id] == pl then
				car.gi[id] = 0
				parse([[speedmod ]]..pl..[[ 0]])
			end
		end
	end
	if car.is[id] == true then
		freeimage(car.img[id])
		car.img[id] = image(car_image,x,y,3)
		imagepos(car.img[id],x,y,player(id,"rot"))
		car.tx[id] = player(id,"tilex")
		car.ty[id] = player(id,"tiley")
		car.is[id] = false
	end
end

function leave_hook(id,reason)
	if id == first_time_id then
		if first_time_map == true then
			first_time_id = 0
		end
	end
	saveslf(id)
	money[id] = 0
	ct[id] = false
	admk[id] = false
	arrest[id] = false
	license[id] = false
	health[id] = false
	tsb[id] = false
	speed[id] = false
	vip[id] = false
	killwho[id] = 0
	pos_x[id] = 0
	pos_y[id] = 0
	die_x[id] = 0
	die_y[id] = 0
	mute[id] = false
	bcol[id] = 1
	blv[1][id] = 0
	blv[2][id] = 0
	language[id] = default_lang
	didonetime[id] = false
	freeimage(car.img[id])
	car.img[id] = 0
	car[id] = false
	car.kills[id] = 0
	car.gi[id] = 0
	car.is[id] = false
	drop_spec[id] = false
	car.x[id] = 0
	car.y[id] = 0
	car.tx[id] = 0
	car.ty[id] = 0
	car.bla[id] = 0
	hnpc[id] = false
	hitman[id] = false
	hitman.k[id] = {USP = 0,Deagle = 0,0,hitman = 0}
	for i = 1,5 do
		if i == 1 then
			hitman.m[i][id] = {false,"Not Done",false}
		else
			hitman.m[i][id] = {false,"Not Aviable",false}
		end
	end
	for i,v in ipairs(hitman.rob) do
		if v == id then
			hitman.rob[i] = 0
		end
	end
	for _,pl in ipairs(player(0,"table")) do
		if pl ~= id then
			if killwho[pl] == id then
				killwho[pl] = 0
			end
			if car.gi[pl] == id then
				car.gi[pl] = 0
			elseif car.gi[id] == pl then
				car.gi[id] = 0
				parse([[speedmod ]]..pl..[[ 0]])
			end
		end
	end
	for i = 1,house.n do
		if house[i] then
			if id == house[i].owner then
				house[i].owner = 0
				if entity(house[i].dx,house[i].dy,"state") == true then
					parse([[trigger ]]..house[i].dname)
				end
			end
		end
	end
	do
		local pl = id
		for id = 1,train.n do
			if train[id] then
				if train[id].p1 == id then
					if speed[train[id].p1] then
						parse([[speedmod ]]..train[id].p1..[[ ]]..yspeed[train[id].p1])
					else
						parse([[speedmod ]]..train[id].p1..[[ 0]])
					end
					train[id].p1 = 0
				elseif train[id].p2 == id then
					if speed[train[id].p2] then
						parse([[speedmod ]]..train[id].p2..[[ ]]..yspeed[train[id].p2])
					else
						parse([[speedmod ]]..train[id].p2..[[ 0]])
					end
					train[id].p2 = 0
				elseif train[id].p3 == id then
					if speed[train[id].p1] then
						parse([[speedmod ]]..train[id].p3..[[ ]]..yspeed[train[id].p3])
					else
						parse([[speedmod ]]..train[id].p3..[[ 0]])
					end
					train[id].p3 = 0
				elseif train[id].p4 == id then
					if speed[train[id].p1] then
						parse([[speedmod ]]..train[id].p4..[[ ]]..yspeed[train[id].p4])
					else
						parse([[speedmod ]]..train[id].p4..[[ 0]])
					end
					train[id].p4 = 0
				end
			end
		end
		for id = 1, npc.n do
			if npc[id] and npc[id].special == 8 then
				if npc[id].p1 == pl or npc[id].p2 == pl then
					npc[id].p = false
				end
			end
		end
	end
end

function menu_hook(id,men,sel)
	local x,y = player(id,"tilex"),player(id,"tiley")
	if men == [[Config]] then
		if sel == 1 then
			npc_c_c_xyrms, npc_c_c_i, npc_c_c_txyp, npc_c_c_s = { 0, 0, 0, 0, 0}, "", { 0, 0 }, { "", "" }
			menu(id,[[NPC Config@b,Add NPC,Add teleport NPC,Add "say" NPC,Add sell NPC]])
		elseif sel == 2 then
			hstt = true
			hsttt = true
			is0, is1, is2, is3, is4, is5, is6, is7, is8, is9 = { "", "", "" },{ "", "", "" },{ "", "", "" },{ "", "", "" },{ "", "", "" },{ "", "", "" },{ "", "", "" },{ "", "", "" },{ "", "", "" },{ "", "", "" }
			is = 0
			trrim = ""
			trrimm = ""
			train_config(id)
		elseif sel == 3 then
			plmim = {"","",""}
			menu(id,[[Roof Config@b,Set middle of roof,Set width|middle has to be set,Set image,Create]])
		elseif sel == 4 then
			menu(id,[[Add zone,Set first position,Set second position,Set name]])
			zx = { 0, 0 }; zy = { 0, 0 }; zname = ""
		elseif sel == 5 then
			local un, dn, rn, ln = "", "", "", ""
			if entity(x - 1, y, "typename") == "Func_DynWall" then
				ln = entity(x - 1, y, "name")
			end
			if entity(x + 1, y, "typename") == "Func_DynWall" then
				rn = entity(x + 1, y, "name")
			end
			if entity(x, y - 1, "typename") == "Func_DynWall" then
				un = entity(x, y - 1, "name")
			end
			if entity(x, y + 1, "typename") == "Func_DynWall" then
				dn = entity(x, y + 1, "name")
			end
			ln = "left: "..ln
			dn = "down: "..dn
			rn = "right: "..rn
			un = "up: "..un
			menu(id,[[House Config@b,Add house,]]..un..[[,]]..dn..[[,]]..ln..[[,]]..rn)
		elseif sel == 6 then
			menu(id,[[Plant Config@b,Use current tileframe for plantable tiles,Set plant mode 1 image,Set plant mode 2 image,Set plant mode 3 image]])
		elseif sel == 7 then
			parse([[speedmod ]]..id..[[ 100]])
		elseif sel == 8 then
			reloadcfg(id)
		elseif sel == 9 then
			local a = ""
			local b = 0
			local c = ""
			for lines in io.lines("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt") do
				b = b + 1
				if b ~= file_lenght("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt") then
					a = a..lines.."\n"
				else
					c = lines
				end
			end
			local f = io.open("sys/lua/RolePlay/map_cfgs/"..map("name").."_auto.txt","w")
			f:write(a)
			f:close()
			if c ~= "" then
				msg2(id,"000255000'"..c.."' undone!")
			else
				msg2(id,"255000000Nothing to undo!")
			end
		end
	elseif men == [[Weapons Page ]]..rpage[id] + 1 then
		if sel > 0 and sel < 8 then
			if weapons_n[page[id] + sel] ~= "EMPTY" then
				selled_ = page[id] + sel
				menu(id,[[Prices,1000$,5000$,10000$,20000$,50000$,100000$,250000$,500000$,1000000$]])
			else
				npc_add_e(id)
			end
		elseif sel == 8 then
			page[id] = page[id] - 7
			rpage[id] = rpage[id] - 1
			if page[id] < 0 then
				page[id] = 84
				rpage[id] = 12
			end
			weapon_menu(id)
		elseif sel == 9 then
			page[id] = page[id] + 7
			rpage[id] = rpage[id] + 1
			if page[id] > 84 then
				page[id] = 0
				rpage[id] = 0
			end
			weapon_menu(id)
		end
	elseif men == [[Prices]] then
		local p = { 1000 ,5000 ,10000 ,20000 ,50000 ,100000 ,250000 ,500000 ,1000000 }
		price_ = p[sel]
		has_w_n = has_w_n + 1
		if has_w_n < 9 then
			table.insert(bl_w_p,selled_)
			table.insert(b_wl_p,price_)
		end
		npc_add_e(id)
	elseif men == [[Add sell NPC]] then
		if sel == 1 then
			npc_c_c_xyrms[1] = player(id,"tilex")
			npc_c_c_xyrms[2] = player(id,"tiley")
			local rot = player(id,"rot") if rot < 0 then rot = rot + 360 end npc_c_c_xyrms[3] = math.floor(rot)
			npc_add_e(id)
		elseif sel == 2 then
			menu(id,[[Add NPC-Set mode@b,Standing|0,Walking up and down|1,Walking from left to right|2]])
		elseif sel == 3 then
			if has_w_n < 9 then
				weapon_menu(id)
			else
				msg2(id,"255255255NPC config done, please create.")
				npc_add_e(id)
			end
		elseif sel == 4 then
			if has_w_n > 0 then
				has_w_n = has_w_n - 1
				table.remove(bl_w_p,selled_)
				table.remove(b_wl_p,price)
			end
			npc_add_e(id)
		elseif sel == 5 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"npc_c_c_i")
			do_in(20000,[[npc_add_e(]]..id..[[)]])
		elseif sel == 6 then
			for i = 1, 9, 1 do
				if not bl_w_p[i] then
					bl_w_p[i] = 0
				end
				if not b_wl_p[i] then
					b_wl_p[i] = 0
				end
			end
			local s = "sell_npc:"..npc_c_c_xyrms[1]..":"..npc_c_c_xyrms[2]..":"..npc_c_c_xyrms[3]..":"..npc_c_c_xyrms[4]..":"
			for i,v in ipairs(bl_w_p) do
				s = s..v..":"
			end
			for i,v in ipairs(b_wl_p) do
				s = s..v..":"
			end
			write_auto(s)
		end
	elseif men == [[Add "say" NPC]] then
		if sel == 1 then
			npc_c_c_xyrms[1] = player(id,"tilex")
			npc_c_c_xyrms[2] = player(id,"tiley")
			local rot = player(id,"rot") if rot < 0 then rot = rot + 360 end npc_c_c_xyrms[3] = math.floor(rot)
			npc_add_s(id)
		elseif sel == 2 then
			menu(id,[[Add NPC-Set mode@b,Standing|0,Walking up and down|1,Walking from left to right|2]])
		elseif sel == 3 then
			msg2(id,"255255255Enter the text in the chat please.")
			answer(id,"npc_c_c_s[1]")
			do_in(20000,[[npc_add_]]..asdasdba..[[(]]..id..[[)]])
		elseif sel == 4 then
			msg2(id,"255255255Enter the text color in the chat please.(R G B, i. e. 255255255)")
			answer(id,"npc_c_c_s[2]")
			do_in(30000,[[npc_add_]]..asdasdba..[[(]]..id..[[)]])
		elseif sel == 5 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"npc_c_c_i")
			do_in(20000,[[npc_add_]]..asdasdba..[[(]]..id..[[)]])
		elseif sel == 6 then
			if npc_c_c_s[2] == "" then npc_c_c_s[2] = "000000000" end
			if npc_c_c_i == "" then npc_c_c_i = "standart" end
			local s = "say_npc:"..npc_c_c_xyrms[1]..":"..npc_c_c_xyrms[2]..":"..npc_c_c_xyrms[3]..":"..npc_c_c_xyrms[4]..":"..npc_c_c_i..":"..npc_c_c_s[2]..":"..npc_c_c_s[1]
			write_auto(s)
		end
	elseif men == [[Add teleport NPC]] then
		if sel == 1 then
			npc_c_c_xyrms[1] = player(id,"tilex")
			npc_c_c_xyrms[2] = player(id,"tiley")
			local rot = player(id,"rot") if rot < 0 then rot = rot + 360 end npc_c_c_xyrms[3] = math.floor(rot)
			npc_add_t(id)
		elseif sel == 2 then
			npc_c_c_txyp[1] = player(id,"tilex")
			npc_c_c_txyp[2] = player(id,"tiley")
			npc_add_t(id)
		elseif sel == 3 then
			menu(id,[[Add NPC-Set mode@b,Standing|0,Walking up and down|1,Walking from left to right|2]])
		elseif sel == 4 then
			msg2(id,"255255255Enter the price in the chat please.")
			answer(id,"npc_c_c_txyp[3]")
			do_in(10000,[[npc_add_]]..asdasdba..[[(]]..id..[[)]])
		elseif sel == 5 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"npc_c_c_i")
			do_in(20000,[[npc_add_]]..asdasdba..[[(]]..id..[[)]])
		elseif sel == 6 then
			local s = "teleport_npc:"..npc_c_c_xyrms[1]..":"..npc_c_c_xyrms[2]..":"..npc_c_c_txyp[1]..":"..npc_c_c_txyp[2]..":"..npc_c_c_txyp[3]..":"..npc_c_c_xyrms[3]..":"..npc_c_c_xyrms[4]..":"..npc_c_c_i
			write_auto(s)
		end
	elseif men == [[Add NPC]] then
		if sel == 1 then
			npc_c_c_xyrms[1] = player(id,"tilex")
			npc_c_c_xyrms[2] = player(id,"tiley")
			local rot = player(id,"rot") if rot < 0 then rot = rot + 360 end npc_c_c_xyrms[3] = math.floor(rot)
			npc_add_n(id)
		elseif sel == 2 then
			menu(id,[[Add NPC-Set mode@b,Standing|0,Walking up and down|1,Walking from left to right|2]])
		elseif sel == 3 then
			menu(id,[[Add NPC-Set special@b,Civilist|0,Bank|1,Hitman|2,Trainticket|3,Killer hitman|4,TicTacToe|5]])
		elseif sel == 4 then
			msg2(id,"255255255Enter the imagepath please.")
			answer(id,"npc_c_c_i")
			do_in(20000,[[npc_add_]]..asdasdba..[[(]]..id..[[)]])
		elseif sel == 5 then
			local s = "npc:"..npc_c_c_xyrms[1]..":"..npc_c_c_xyrms[2]..":"..npc_c_c_xyrms[3]..":"..npc_c_c_xyrms[4]..":"..npc_c_c_xyrms[5]..":"..npc_c_c_i
			write_auto(s)
		end
	elseif men == [[Add NPC-Set mode]] then
		if type(sel) == "number" and sel ~=0 and sel ~= 6 then
			npc_c_c_xyrms[4] = sel - 1
		end
		if sel == 6 then
			npc_c_c_xyrms[4] = 8
		end
		loadstring([[npc_add_]]..asdasdba..[[(]]..id..[[)]])
	elseif men == [[Add NPC-Set special]] then
		if type(sel) == "number" and sel ~=0 then
			npc_c_c_xyrms[5] = sel - 1
		end
		loadstring([[npc_add_]]..asdasdba..[[(]]..id..[[)]])
	elseif men == [[NPC Config]] then
		if sel == 1 then
			npc_add_n(id)
			asdasdba = "n"
		elseif sel == 2 then
			npc_add_t(id)
			asdasdba = "t"
		elseif sel == 3 then
			npc_add_s(id)
			asdasdba = "s"
		elseif sel == 4 then
			asdasdba = "e"
			bl_w_p = { }
			b_wl_p = { }
			has_w_n = 0
			npc_add_e(id)
		end
	elseif men == [[Train Config]] then
		if sel == 1 then
			if is < 10 then
				menu(id,[[Train Rot,Up,Down,Left,Right]])
			else
				msg2(id,"255255255Train config done, please create.")
				train_config(id)
			end
		elseif sel == 2 then
			if is ~= 0 then
				is = is - 1
			end
			loadstring("is"..is.."[1] = 0")
			loadstring("is"..is.."[2] = 0")
			loadstring("is"..is.."[3] = 0")
			train_config(id)
		elseif sel == 3 then
			if hstt == true then hstt = false else hstt = true end
			train_config(id)
		elseif sel == 4 then
			if hsttt == true then hsttt = false else hsttt = true end
			train_config(id)
		elseif sel == 5 or sel == 6 then
			train_config(id)
		elseif sel == 7 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"trrim")
			do_in(20000,[[train_config(]]..id..[[)]])
		elseif sel == 8 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"trrimm")
			do_in(20000,[[train_config(]]..id..[[)]])
		elseif sel == 9 then
			if is == 10 then
				if trrimm == "" then trrimm = "standart" end
				ssrs = "train:"..tostring(hstt)..":"..trrimm..":"
				for i = 0, 9, 1 do
					loadstring("ssrs = ssrs..is"..i.."[1]..':'..is"..i.."[2]..':'..is"..i.."[3]..':'")
				end
				if string.sub(ssrs, -1) == ":" then ssrs = string.sub(ssrs, 1, -1) end
				ssrs = ssrs..":"..tostring(hsttt)
				write_auto(ssrs)
				if trrim ~= "" then
					write_auto("rail_image:"..trrim)
				end
			else
				msg2(id,"255000000You have to set all points! (Can be the same for the end.)")
				train_config(id)
			end
		end
	elseif men == [[Train Rot]] then
		if sel == 1 then
			loadstring("is"..is.."[3] = 0")
			loadstring("is"..is.."[1] = "..player(id,"tilex"))
			loadstring("is"..is.."[2] = "..player(id,"tiley"))
			train_config(id)
		elseif sel == 2 then
			loadstring("is"..is.."[3] = 180")
			loadstring("is"..is.."[1] = "..player(id,"tilex"))
			loadstring("is"..is.."[2] = "..player(id,"tiley"))
			train_config(id)
		elseif sel == 3 then
			loadstring("is"..is.."[3] = 270")
			loadstring("is"..is.."[1] = "..player(id,"tilex"))
			loadstring("is"..is.."[2] = "..player(id,"tiley"))
			train_config(id)
		elseif sel == 4 then
			loadstring("is"..is.."[3] = 90")
			loadstring("is"..is.."[1] = "..player(id,"tilex"))
			loadstring("is"..is.."[2] = "..player(id,"tiley"))
			train_config(id)
		end
		is = is + 1
	elseif men == [[Roof Config]] then
		if sel == 1 then
			rfx = player(id,"tilex")
			rfy = player(id,"tiley")
		elseif sel == 2 then
			rfw = math.sqrt(player(id,"tilex") - rfx,player(id,"tiley") - rfy)
		elseif sel == 3 then
			rfimg = ""
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"rfimg")
		elseif sel == 4 then
			write_auto("roof:"..rfx..":"..rfy..":"..rfw..":"..rfimg)
		end
	elseif men == [[Add zone]] then
		if sel == 1 then
			zx[1] = player(id,"tilex")
			zy[1] = player(id,"tiley")
			menu(id,[[Add zone,Set first position,Set second position,Set name]])
		elseif sel == 2 then
			zx[2] = player(id,"tilex")
			zy[2] = player(id,"tiley")
			menu(id,[[Add zone,Set first position,Set second position,Set name]])
		elseif sel == 3 then
			msg2(id,"255255255Enter the name of the zone in the chat please.")
			answer(id,"zname")
			do_in(20000,[[
			local v = "zone:]]..zx[1]..[[:]]..zy[1]..[[:]]..zx[2]..[[:]]..zy[2]..[[:"..zname
			write_auto(v)]])
		end
	elseif men == [[House Config]] then
		msg2(id,"255255255Enter the name of the dynwall in the chat please.")
		towriteinthat = ""
		towriteinthat2 = 0
		towriteinthat3 = {}
		answer(id,"towriteinthat")
		NUMBER = 0
		do_in(10000,[[
		msg2(]]..id..[[,"255255255Enter the price of the house in the chat please.")
		answer(]]..id..[[,"towriteinthat2")]])
		do_in(20000,[[
		msg2(]]..id..[[,"255255255Enter the number of buttons in the chat please.")
		answer(]]..id..[[,"NUMBER")]])
		do_in(30000,[[
		do_in(NUMBER * 10000,'local s = "house:"..towriteinthat2..":"..towriteinthat..":" for i,x in ipairs(towriteinthat3) do s = s..x..":" end write_auto(s)') for i = 0, NUMBER - 1, 1 do do_in(i * 7500,'msg2(]]..id..[[,"255255255Please trigger the buttons.['..(i + 1)..'/'..NUMBER..']") ftrigger(]]..id..[[,"towriteinthat3")') end]])
	elseif men == [[Plant Config]] then
		if sel == 1 then
			local f = tile(player(id,"tilex"),player(id,"tiley"),"frame")
			write_auto("plantframe:"..f)
			msg2(id,string.format("000200000%s is the new planttileframe.",f))
		elseif sel == 2 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"plmim[1]")
			do_in(30000,"menu("..id..",[[Plant Config@b,Use current tileframe for plantable tiles,Set plant mode 1 image,Set plant mode 2 image,Set plant mode 3 image]]) write_auto('plant_mode1:'..plmim[1])")
		elseif sel == 3 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"plmim[2]")
			do_in(30000,"menu("..id..",[[Plant Config@b,Use current tileframe for plantable tiles,Set plant mode 1 image,Set plant mode 2 image,Set plant mode 3 image]]) write_auto('plant_mode2:'..plmim[2]")
		elseif sel == 4 then
			msg2(id,"255255255Enter the imagepath in the chat please.")
			answer(id,"plmim[3]")
			do_in(30000,"menu("..id..",[[Plant Config@b,Use current tileframe for plantable tiles,Set plant mode 1 image,Set plant mode 2 image,Set plant mode 3 image]]) write_auto('plant_mode3:'..plmim[3]")
		end
	elseif men == [[Drop Menu]] then
		local moneys = money[id]
		if sel == 1 then
			if moneys > 99 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 100
				end
				parse([[spawnitem 66 ]]..x..[[ ]]..y)
			else
				nom(id)
			end
		elseif sel == 2 then 
			if moneys > 499 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 500
				end
				parse([[spawnitem 67 ]]..x..[[ ]]..y)
			else
				nom(id)
			end
		elseif sel == 3 then
			if moneys > 999 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 1000
				end
				parse([[spawnitem 68 ]]..x..[[ ]]..y)
			else
				nom(id)
			end
		elseif sel == 4 then
			if moneys > 1999 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 2000
				end
				parse([[spawnitem 68 ]]..x..[[ ]]..y)
				parse([[spawnitem 68 ]]..x..[[ ]]..y)
			else
				nom(id)
			end
		elseif sel == 5 then
			if moneys > 4999 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 5000
				end
				for i = 1,5 do
					parse([[spawnitem 68 ]]..x..[[ ]]..y)
				end
			else
				nom(id)
			end
		elseif sel == 6 then
			if moneys > 9999 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 10000
				end
				for i = 1,10 do
					parse([[spawnitem 68 ]]..x..[[ ]]..y)
				end
			else
				nom(id)
			end
		elseif sel == 7 then
			if moneys > 49999 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 50000
				end
				parse([[spawnitem 56 ]]..x..[[ ]]..y)
			else
				nom(id)
			end
		elseif sel == 8 then
			if moneys > 99999 then
				if type(money[id]) ~= "string" then
					money[id] = money[id] - 100000
				end
				for i = 1,2 do
					parse([[spawnitem 56 ]]..x..[[ ]]..y)
				end
			else
				nom(id)
			end
		elseif sel == 9 then
			if license[id] then
				drop_spec[id] = true
			end
		end
		if sel > 0 and sel < 9 then
			menue(id)
		end
		updatehud(id)
	elseif men == [[Language]] then
		if sel < 9 then
			language[id] = languages2[sel]
			updatehud(id)
		elseif sel == 9 then
			local langs = toTable(languages,",")
			for i = 9,16 do
				if not langs[i] then langs[i] = "" end
			end
			menu(id,[[Language 2,]]..langs[9]..[[,]]..langs[10]..[[,]]..langs[11]..[[,]]..langs[12]..[[,]]..langs[13]..[[,]]..langs[14]..[[,]]..langs[15]..[[,]]..langs[16]..[[,]]..lang[language[id]][14])
		end
	elseif men == [[Language 2]] then
		if sel < 9 then
			language[id] = languages2[sel + 8]
			updatehud(id)
		elseif sel == 9 then
			local langs = toTable(languages,",")
			menu(id,[[Language,]]..langs[1]..[[,]]..langs[2]..[[,]]..langs[3]..[[,]]..langs[4]..[[,]]..langs[5]..[[,]]..langs[6]..[[,]]..langs[7]..[[,]]..langs[8]..[[,]]..lang[language[id]][122])
		end
	elseif men == [[T Menu]] then
		if sel == 1 then
			menu(id,[[T Insta Equip,M3|$40000,AK-47|$75000,Deagle|$20000,Glock|$10000,Knife|$7500,,,]]..lang[language[id]][14])
		elseif sel == 2 then
			if license[id] == true then
				tele_menu(id)
			else
				if type(money[id]) ~= "string" then
					if money[id] >= 250000 then
						money[id] = money[id] - 250000
						updatehud(id)
						license[id] = true
						msg2(id,"000255000"..lang[language[id]][18].."!@C")
					else
						nom(id)
					end
				else
					license[id] = true
					msg2(id,"000255000"..lang[language[id]][18].."!@C")
				end
			end
		elseif sel == 3 then
			menu(id,[[Plants,]]..lang[language[id]][19]..[[|$250,]]..lang[language[id]][20]..[[|$500,]]..lang[language[id]][21]..[[|$1000,]]..lang[language[id]][22]..[[|$5000]])
		elseif sel == 4 then
			help_men(id)
		elseif sel == 5 then
			langsel(id)
		end
	elseif men == [[Help]] then
		if sel == 1 or sel == 2 or sel == 3 or sel == 4 or sel == 5 or sel == 6 or sel == 7 or sel == 8 then
			help_men(id)
		elseif sel == 9 then
			menu(id,[[How do I play this mod?@b,]]..lang[language[id]][23]..[[,]]..lang[language[id]][43]..[[,]]..lang[language[id]][44]..[[,]]..lang[language[id]][45]..[[,]]..lang[language[id]][46]..[[,]]..lang[language[id]][47]..[[,]]..lang[language[id]][48])
		end
	elseif men == [[T Insta Equip]] then
		if sel == 1 then
			if type(money[id]) ~= "string" then
				if money[id] >= 40000 then
					money[id] = money[id] - 40000
					equip(id,10)
				else
					nom(id)
				end
			end
		elseif sel == 2 then
			if type(money[id]) ~= "string" then
				if money[id] >= 75000 then
					money[id] = money[id] - 75000
					equip(id,30)
				else
					nom(id)
				end
			end
		elseif sel == 3 then
			if type(money[id]) ~= "string" then
				if money[id] >= 20000 then
					money[id] = money[id] - 20000
					equip(id,3)
				else
					nom(id)
				end
			end
		elseif sel == 4 then
			if type(money[id]) ~= "string" then
				if money[id] >= 10000 then
					money[id] = money[id] - 10000
					equip(id,2)
				else
					nom(id)
				end
			end
		elseif sel == 5 then
			if type(money[id]) ~= "string" then
				if money[id] >= 7500 then
					money[id] = money[id] - 7500
					equip(id,50)
				else
					nom(id)
				end
			end
		elseif sel == 8 then
			t_menu(id)
		end
		updatehud(id)
	elseif men == [[CT Menu]] then
		if sel == 1 then
			menu(id,[[CT Insta Equip,M3,M4A1,AK-47,Deagle,Five-Seven,Knife,All,]]..lang[language[id]][14])
		elseif sel == 2 then
			tele_menu(id)
		elseif sel == 3 then
			menu(id,[[Plants,]]..lang[language[id]][19]..[[|$250,]]..lang[language[id]][20]..[[|$500,]]..lang[language[id]][21]..[[|$1000,]]..lang[language[id]][22]..[[|$5000]])
		elseif sel == 4 then
			menu(id,[[Build,]]..lang[language[id]][24]..[[,]]..lang[language[id]][25]..[[,]]..lang[language[id]][26]..[[,,,,,]]..lang[language[id]][14])
		elseif sel == 5 then
			systems(id)
		elseif sel == 6 then
			msg2(id,"255255255!l <Lua> --"..lang[language[id]][27])
			msg2(id,"255255255!i <weapon id> --"..lang[language[id]][28])
			msg2(id,"255255255!s <player id> <speed> --"..lang[language[id]][29])
			msg2(id,"255255255!k <player id> --"..lang[language[id]][30])
			msg2(id,"255255255!x <player id> --"..lang[language[id]][31])
			msg2(id,"255255255!g <player id> --"..lang[language[id]][32])
			msg2(id,"255255255!b <player id> --"..lang[language[id]][33])
		elseif sel == 7 then
			help_men(id)
		elseif sel == 8 then
			langsel(id)
		elseif sel == 9 then
			if hasright(id,"z") or hasright(id,"s") then
				menu(id,[[Restart/Reload@b,]]..lang[language[id]][132]..[[,]]..lang[language[id]][134]..[[,]]..lang[language[id]][135]..[[,]]..string.format(lang[language[id]][138],map("name")))
			end
		end
	elseif men == [[Restart/Reload]] then
		if sel == 1 then
			reloadcfg(id)
		elseif sel == 2 then
			parse([[restartround 5]])
		elseif sel == 3 then
			parse([[changemap ]]..map("name"))
		elseif sel == 4 then
			first_time_map = true
			first_time_id = id
		end
	elseif men == [[Plants]] then
		if sel == 1 then
			if money[id] >= 250 then
				local x,y = player(id,"tilex"),player(id,"tiley")
				local try = new_plant(x,y)
				if try ~= false then
					if type(money[id]) ~= "string" then
						money[id] = money[id] - 250
						updatehud(id)
					end
				else
					msg2(id,"255000000"..lang[language[id]][34].."!@C")
				end
				menu(id,[[Plants,]]..lang[language[id]][19]..[[|$250,]]..lang[language[id]][20]..[[|$500,]]..lang[language[id]][21]..[[|$1000,]]..lang[language[id]][22]..[[|$5000]])
			else
				nom(id)
			end
		elseif sel == 2 then
			if money[id] >= 500 then
				local x,y = player(id,"tilex"),player(id,"tiley")
				local try = new_plant(x,y,1)
				if try ~= false then
					if type(money[id]) ~= "string" then
						money[id] = money[id] - 500
						updatehud(id)
					end
				else
					msg2(id,"255000000"..lang[language[id]][34].."!@C")
				end
				menu(id,[[Plants,]]..lang[language[id]][19]..[[|$250,]]..lang[language[id]][20]..[[|$500,]]..lang[language[id]][21]..[[|$1000,]]..lang[language[id]][22]..[[|$5000]])
			else
				nom(id)
			end
		elseif sel == 3 then
			if money[id] >= 1000 then
				local x,y = player(id,"tilex"),player(id,"tiley")
				local try = new_plant(x,y,2)
				if try ~= false then
					if type(money[id]) ~= "string" then
						money[id] = money[id] - 1000
						updatehud(id)
					end
				else
					msg2(id,"255000000"..lang[language[id]][34].."!@C")
				end
				menu(id,[[Plants,]]..lang[language[id]][19]..[[|$250,]]..lang[language[id]][20]..[[|$500,]]..lang[language[id]][21]..[[|$1000,]]..lang[language[id]][22]..[[|$5000]])
			else
				nom(id)
			end
		elseif sel == 4 then
			if money[id] >= 5000 then
				local x,y = player(id,"tilex"),player(id,"tiley")
				local try = new_plant(x,y,3)
				if try ~= false then
					if type(money[id]) ~= "string" then
						money[id] = money[id] - 5000
						updatehud(id)
					end
				else
					msg2(id,"255000000"..lang[language[id]][34].."!@C")
				end
				menu(id,[[Plants,]]..lang[language[id]][19]..[[|$250,]]..lang[language[id]][20]..[[|$500,]]..lang[language[id]][21]..[[|$1000,]]..lang[language[id]][22]..[[|$5000]])
			else
				nom(id)
			end
		end
	elseif men == [[Systems]] then
		for i = 4,8 do
			if sel == i then
				sell[id] = i
				pc_1(id)
				break
			end
		end
		if sel == 1 then
			sell[id] = 1
			pc_1(id)
		elseif sel == 2 then
			local a = lang[language[id]][35]
			menu(id,[[Speed,5|]]..a..[[,10|]]..a..[[,15|]]..a..[[,25|]]..a..[[,50|]]..a..[[,75|]]..a..[[,80|]]..a..[[,100|]]..a..[[,]]..lang[language[id]][14])
			sell[id] = 2
		elseif sel == 3 then
			local a = lang[language[id]][36]
			menu(id,[[Health,125|]]..a..[[,150|]]..a..[[,200|]]..a..[[,250|]]..a..[[,,,,]]..lang[language[id]][14])
			sell[id] = 3
		elseif sel == 9 then
			ct_menu(id)
		end
	elseif men == [[Build]] then
		if sel == 1 then
			menu(id,[[Build Color,]]..lang[language[id]][37]..[[,]]..lang[language[id]][38]..[[,]]..lang[language[id]][39]..[[,]]..lang[language[id]][40])
		elseif sel == 2 then
			menu(id,[[Build Level,Turret (]]..blv[1][id]..[[),Supply (]]..blv[2][id]..[[),,,,,,]]..lang[language[id]][14])
		elseif sel == 3 then
			if freeb == true then
				freeb = false
				msg("255000000",26," de-",41,"!@C")
			else
				freeb = true
				msg("000255000",26," ",41,"!@C")
			end
		elseif sel == 8 then
			ct_menu(id)
		end
	elseif men == [[Health]] then
		if sel == 1 then
			myhealth[id] = 125
			pc_1(id)
		elseif sel == 2 then
			myhealth[id] = 150
			pc_1(id)
		elseif sel == 3 then
			myhealth[id] = 200
			pc_1(id)
		elseif sel == 4 then
			myhealth[id] = 250
			pc_1(id)
		elseif sel == 8 then
			systems(id)
		end
	elseif men == [[Build Level]] then
		if sel == 1 then
			menu(id,[[Turret Level,]]..lang[language[id]][49]..[[,]]..lang[language[id]][50]..[[,]]..lang[language[id]][51])
		elseif sel == 2 then
			menu(id,[[Supply Level,]]..lang[language[id]][52]..[[,]]..lang[language[id]][53])
		elseif sel == 8 then
			ct_menu(id)
		end
	elseif men == [[Turret Level]] then
		if sel == 1 then
			blv[1][id] = 1
			msg2(id,lang[language[id]][54])
		elseif sel == 2 then
			blv[1][id] = 2
			msg2(id,lang[language[id]][55])
		elseif sel == 3 then
			blv[1][id] = 3
			msg2(id,lang[language[id]][56])
		end
	elseif men == [[Supply Level]] then
		if sel == 1 then
			blv[2][id] = 1
			msg2(id,lang[language[id]][57])
		elseif sel == 2 then
			blv[2][id] = 2
			msg2(id,lang[language[id]][58])
		end
	elseif men == [[Build Color]] then
		if sel == 1 then
			bcol[id] = 1
			msg2(id,"000000255"..lang[language[id]][59])
		elseif sel == 2 then
			bcol[id] = 2
			msg2(id,"255000000"..lang[language[id]][60])
		elseif sel == 3 then
			bcol[id] = 3
			msg2(id,lang[language[id]][61])
		elseif sel == 4 then
			bcol[id] = 4
			msg2(id,"255255255"..lang[language[id]][62])
		end
	elseif men == [[CT Insta Equip]] then
		if sel == 1 then
			equip(id,10)
		elseif sel == 2 then
			equip(id,32)
		elseif sel == 3 then
			equip(id,30)
		elseif sel == 4 then
			equip(id,3)
		elseif sel == 5 then
			equip(id,6)
		elseif sel == 6 then
			equip(id,50)
		elseif sel == 7 then
			equip(id,10,32,30,3,6,50)
		elseif sel == 8 then
			ct_menu(id)
		end
	elseif men == [[Teleport-Menu]] then
		if player(id,"health") > 0 then
			if sel == 1 then
				if pos_x[id] ~= 0 and pos_y[id] ~= 0 then
					if type(money[id]) ~= "string" then
						if money[id] >= 5000 then
							money[id] = money[id] - 5000
							setpos(id,pos_x[id],pos_y[id])
						else
							nom(id)
						end
					else
						setpos(id,pos_x[id],pos_y[id])
					end
				else
					msg2(id,"255000000"..lang[language[id]][63])
				end
			elseif sel == 2 then
				pos_x[id] = player(id,"x")
				pos_y[id] = player(id,"y")
				msg2(id,lang[language[id]][64])
				msg2(id,"X: "..math.floor(pos_x[id]).." Y: "..math.floor(pos_y[id]))
			elseif sel == 3 then
				if tsb[id] == true then
					tsb[id] = false
					msg2(id,"000255000"..lang[language[id]][65])
				else
					tsb[id] = true
					msg2(id,"000255000"..lang[language[id]][66])
				end
			elseif sel == 4 then
				if hasright(id, "z") or hasright(id, "a") then
					arrest.x[id] = player(id,"x")
					arrest.y[id] = player(id,"y")
					msg2(id,"X: "..math.floor(arrest.x[id]/32).." Y: "..math.floor(arrest.y[id]/32))
				end
			end
		end
	elseif men == [[Speed]] then
		if sel == 1 then
			myspeed[id] = 5
			pc_1(id)
		elseif sel == 2 then
			myspeed[id] = 10
			pc_1(id)
		elseif sel == 3 then
			myspeed[id] = 15
			pc_1(id)
		elseif sel == 4 then
			myspeed[id] = 25
			pc_1(id)
		elseif sel == 5 then
			myspeed[id] = 50
			pc_1(id)
		elseif sel == 6 then
			myspeed[id] = 75
			pc_1(id)
		elseif sel == 7 then
			myspeed[id] = 80
			pc_1(id)
		elseif sel == 8 then
			myspeed[id] = 100
			pc_1(id)
		elseif sel == 9 then
			systems(id)
		end
	end
	local fun = function(n) if n == 1 then return 1,7,0 elseif n == 2 then return 8,14,-7 elseif n == 3 then return 15,21,-14 elseif n == 4 then return 22,28,-21 elseif n == 5 then return 29,32,-28 end end
	local pll = function(id,n) if n == 1 then ct_menu(id) elseif n == 2 then pc_1(id) elseif n == 3 then pc_2(id) elseif n == 4 then pc_3(id) elseif n == 5 then pc_4(id) end end
	local pll2 = function(id,n) if n == 1 then pc_2(id) elseif n == 2 then pc_3(id) elseif n == 3 then pc_4(id) elseif n == 4 then pc_5(id) elseif n == 5 then pc_5(id) end end
	for plni = 1,5 do
		if men == [[Players ]]..plni then
			local bla,blu,bll,zu = fun(plni)
			for pl = bla,blu do
				if sel == pl - bll then
					if sell[id] == 1 then
						if hasright(id, "z") or hasright(id, "l") then
							if license[pl] == true then
								license[pl] = false
								msg2(pl,"255000000"..string.format(lang[language[pl]][67],player(id,"name")).."@C")
								msg2(id,"255000000"..string.format(lang[language[id]][68],player(pl,"name")).."@C")
							else
								license[pl] = true
								msg2(pl,"000255000"..string.format(lang[language[pl]][69],player(id,"name")).."@C")
								msg2(id,"000255000"..string.format(lang[language[id]][70],player(pl,"name")).."@C")
							end
						end
					elseif sell[id] == 2 then
						if hasright(id, "z") or hasright(id, "p") then
							if speed[pl] == true then
								speed[pl] = false
								yspeed[pl] = 5
								parse([[speedmod ]]..pl..[[ 0]])
								msg2(pl,"255000000"..string.format(lang[language[pl]][71],player(id,"name")).."@C")
								msg2(id,"255000000"..string.format(lang[language[id]][72],player(pl,"name")).."@C")
							else
								speed[pl] = true
								yspeed[pl] = myspeed[id]
								parse([[speedmod ]]..pl..[[ ]]..yspeed[pl])
								msg2(pl,"000255000"..string.format(lang[language[pl]][73],player(id,"name"),yspeed[pl]).."@C")
								msg2(id,"000255000"..string.format(lang[language[id]][74],player(pl,"name"),yspeed[pl]).."@C")
							end
						end
					elseif sell[id] == 3 then
						if hasright(id, "z") or hasright(id, "h") then
							if health[pl] == true then
								health[pl] = false
								yhealth[pl] = 125
								parse([[setmaxhealth ]]..pl..[[ 100]])
								msg2(pl,"255000000"..string.format(lang[language[pl]][75],player(id,"name")).."@C")
								msg2(id,"255000000"..string.format(lang[language[id]][76],player(pl,"name")).."@C")
							else
								health[pl] = true
								yhealth[pl] = myhealth[id]
								parse([[setmaxhealth ]]..pl..[[ ]]..yhealth[pl])
								msg2(pl,"000255000"..string.format(lang[language[pl]][77],player(id,"name"),yhealth[pl]).."@C")
								msg2(id,"000255000"..string.format(lang[language[id]][78],player(pl,"name"),yhealth[pl]).."@C")
							end
						end
					elseif sell[id] == 4 then
						if hasright(id, "z") or hasright(id, "m") then
							if mute[pl] == true then
								mute[pl] = false
								msg2(pl,"000255000"..string.format(lang[language[pl]][79],player(id,"name")).."@C")
								msg2(id,"000255000"..string.format(lang[language[id]][80],player(pl,"name")).."@C")
							else
								mute[pl] = true
								msg2(pl,"255000000"..string.format(lang[language[pl]][81],player(id,"name")).."@C")
								msg2(id,"255000000"..string.format(lang[language[id]][82],player(pl,"name")).."@C")
							end
						end
					elseif sell[id] == 5 then
						if hasright(id, "z") or hasright(id, "i") then
							parse([[killplayer ]]..pl)
							msg2(id,"255000000"..string.format(lang[language[id]][83],player(pl,"name")).."@C")
						else
							msg2(id,"255000000"..lang[language[id]][84])
						end
					elseif sell[id] == 6 then
						if hasright(id, "z") or hasright(id, "k") then
							parse([[kick ]]..pl)
							msg("255255255"..player(pl,"name").." ",88," "..player(id,"name").."@C")
						else
							msg2(id,"255000000"..lang[language[id]][85])
						end
					elseif sell[id] == 7 then
						if hasright(id, "z") or hasright(id, "b") then
							parse([[banname ]]..player(pl,"name"))
							msg("255255255"..player(pl,"name").." ",89," "..player(id,"name").."@C")
						else
							msg2(id,"255000000"..lang[language[id]][86])
						end
					elseif sell[id] == 8 then
						if hasright(id, "z") or hasright(id, "v") then
							if vip[pl] ==true then
								vip[pl] = false
								parse([[maket ]]..pl)
								msg2(pl,"255000000"..string.format(lang[language[pl]][90],player(id,"name")).."@C")
								msg2(id,"255000000"..string.format(lang[language[id]][91],player(pl,"name")).."@C")
							else
								vip[pl] = true
								license[pl] = true
								parse([[makect ]]..pl)
								msg2(pl,"000255000"..string.format(lang[language[pl]][92],player(id,"name")).."@C")
								msg2(id,"000255000"..string.format(lang[language[id]][93],player(pl,"name")).."@C")
							end
						else
							msg2(id,[[255000000]]..lang[language[id]][87])
						end
					end
				end
			end
			if sel == 8 then
				pll(id,plni)
			elseif sel == 9 then
				pll2(id,plni)
			end
		end
	end
	do
		local pl = id
		for id = 1,house.n do
			if house[id] then
				if men == [[House ]]..id then
					if sel == 2 then
						if money[pl] >= house[id].price then
							money[pl] = money[pl] - house[id].price
							updatehud(pl)
							house[id].owner = pl
							msg2(pl,"000255000"..lang[language[pl]][131])
						else
							nom(pl)
						end
					end
				end
			end
		end
	end
	for n = 1,npc.n do
		if npc[n] then
			if men == [[NPC ID: ]]..n then
				if npc[n].special == 0 then
					msg2(id,"255255255"..lang[language[id]][99])
					npc[n].menu = 0
					hnpc[id] = false
				elseif npc[n].special == 1 then
					if sel == 2 then
						menu(id,[[(Bank Money)NPC: ]]..n..[[,100$,500$,1000$,2000$,5000$,10000$,50000$,100000$,$$$$$$]])
					elseif sel == 3 then
						menu(id,[[(Bank Money)NPC :]]..n..[[,100$,500$,1000$,2000$,5000$,10000$,50000$,100000$,$$$$$$]])
					elseif sel == 5 then
						local mr = math.random(0,2)
						if mr == 0 then
							msg2(hitman.rob[2],"255255255"..lang[language[hitman.rob[2]]][117])
							msg2(hitman.rob[3],"255255255"..lang[language[hitman.rob[3]]][117])
							msg2(hitman.rob[4],"255255255"..lang[language[hitman.rob[4]]][117])
							money[hitman.rob[2]] = money[hitman.rob[2]] - 20000
							money[hitman.rob[3]] = money[hitman.rob[3]] - 20000
							money[hitman.rob[4]] = money[hitman.rob[4]] - 20000
							updatehud(hitman.rob[2])
							updatehud(hitman.rob[3])
							updatehud(hitman.rob[4])
							hitman.rob[1] = false
							hitman.rob[2] = 0
							hitman.rob[3] = 0
							hitman.rob[4] = 0
							hitman.rob[5] = 0
						else
							msg2(hitman.rob[2],"255255255"..lang[language[hitman.rob[2]]][116])
							msg2(hitman.rob[3],"255255255"..lang[language[hitman.rob[3]]][116])
							msg2(hitman.rob[4],"255255255"..lang[language[hitman.rob[4]]][116])
							msg2(hitman.rob[2],"000255000"..lang[language[hitman.rob[2]]][103].."!".." +7000$")
							msg2(hitman.rob[3],"000255000"..lang[language[hitman.rob[3]]][103].."!".." +7000$")
							msg2(hitman.rob[4],"000255000"..lang[language[hitman.rob[4]]][103].."!".." +7000$")
							money[hitman.rob[2]] = money[hitman.rob[2]] + 7000
							money[hitman.rob[3]] = money[hitman.rob[3]] + 7000
							money[hitman.rob[4]] = money[hitman.rob[4]] + 7000
							updatehud(hitman.rob[2])
							updatehud(hitman.rob[3])
							updatehud(hitman.rob[4])
							hitman.m[3][hitman.rob[5]][1] = true
							hitman.rob[1] = false
							hitman.rob[2] = 0
							hitman.rob[3] = 0
							hitman.rob[4] = 0
							hitman.rob[5] = 0
							hnpc[id] = false
							npc[n].menu = 0
							msg2(id,"255255255"..lang[language[id]][99])
						end
						hnpc[id] = false
						npc[n].menu = 0
					else
						hnpc[id] = false
						npc[n].menu = 0
						msg2(id,"255255255"..lang[language[id]][99])
					end
				elseif npc[n].special == 2 then
					if sel == 1 then
						if hitman.m[1][id][1] == false then
							hitman.m[1][id][3] = true
							equip(id,3)
							msg2(id,lang[language[id]][104])
						else
							msg2(id,lang[language[id]][109])
						end
					elseif sel == 2 then
						if hitman.m[2][id][1] == false then
							if hitman.m[1][id][1] == true then
								hitman.m[2][id][3] = true
								msg2(id,lang[language[id]][105])
							end
						else
							msg2(id,lang[language[id]][109])
						end
					elseif sel == 3 then
						if hitman.m[3][id][1] == false then
							if nhitmans()[1] >= 3 then
								hitman.m[3][id][3] = true
								local hh = nhitmans()[2]
								hitman.rob[2] = hh[1]
								hitman.rob[3] = hh[2]
								hitman.rob[4] = hh[3]
								hitman.rob[5] = id
								msg2(hh[1],"000255000"..lang[language[hh[1]]][115].."@C")
								msg2(hh[2],"000255000"..lang[language[hh[2]]][115].."@C")
								msg2(hh[3],"000255000"..lang[language[hh[3]]][115].."@C")
								msg2(id,lang[language[id]][106])
								hitman.rob[1] = true
							else
								msg2(id,"255000000"..lang[language[id]][118])
							end
						else
							msg2(id,lang[language[id]][109])
						end
					elseif sel == 4 then
						if hitman.m[4][id][1] == false then
							if hitman.m[3][id][1] == true then
								hitman.m[4][id][3] = true
								msg2(id,lang[language[id]][107])
							end
						else
							msg2(id,lang[language[id]][109])
						end
					elseif sel == 5 then
						if hitman.m[5][id][1] == false then
							if hitman.m[4][id][1] == true then
								hitman.m[5][id][3] = true
								msg2(id,lang[language[id]][108])
							end
						else
							msg2(id,lang[language[id]][109])
						end
					end
					hnpc[id] = false
					npc[n].menu = 0
					msg2(id,"255255255"..lang[language[id]][99])
				elseif npc[n].special == 3 then
					if sel == 1 then
						if train.ticket[id] == true then
							msg2(id,"255000000"..lang[language[id]][123])
						else
							money[id] = money[id] - 25
							updatehud(id)
							train.ticket[id] = true
							msg2(id,"255255255"..lang[language[id]][113])
						end
					end
					hnpc[id] = false
					npc[n].menu = 0
					msg2(id,"255255255"..lang[language[id]][99])
				elseif npc[n].special == 5 then
					if sel == 2 then
						if money[id] >= npc[n].tprc then
							money[id] = money[id] - npc[n].tprc
							updatehud(id)
							setpos(id,npc[n].ttx,npc[n].tty)
						else
							nom(id)
						end
					end
					hnpc[id] = false
					npc[n].menu = 0
					msg2(id,"255255255"..lang[language[id]][99])
				elseif npc[n].special == 7 then
					if npc[n].bp[sel] and money[id] then
						if money[id] >= npc[n].bp[sel] then
							money[id] = money[id] - npc[n].bp[sel]
							equip(id, npc[n].bw[sel])
							updatehud(id)
						else
							nom(id)
						end
					end
					hnpc[id] = false
					npc[n].menu = 0
					msg2(id,"255255255"..lang[language[id]][99])
				end
			elseif men == [[(Bank Money)NPC :]]..n then
				if sel == 1 then
					if bank[id] >= 100 then
						bank[id] = bank[id] - 100
						money[id] = money[id] + 100
					else
						nom(id)
					end
				elseif sel == 2 then
					if bank[id] >= 500 then
						bank[id] = bank[id] - 500
						money[id] = money[id] + 500
					else
						nom(id)
					end
				elseif sel == 3 then
					if bank[id] >= 1000 then
						bank[id] = bank[id] - 1000
						money[id] = money[id] + 1000
					else
						nom(id)
					end
				elseif sel == 4 then
					if bank[id] >= 2000 then
						bank[id] = bank[id] - 2000
						money[id] = money[id] + 2000
					else
						nom(id)
					end
				elseif sel == 5 then
					if bank[id] >= 5000 then
						bank[id] = bank[id] - 5000
						money[id] = money[id] + 5000
					else
						nom(id)
					end
				elseif sel == 6 then
					if bank[id] >= 10000 then
						bank[id] = bank[id] - 10000
						money[id] = money[id] + 10000
					else
						nom(id)
					end
				elseif sel == 7 then
					if bank[id] >= 50000 then
						bank[id] = bank[id] - 50000
						money[id] = money[id] + 50000
					else
						nom(id)
					end
				elseif sel == 8 then
					if bank[id] >= 100000 then
						bank[id] = bank[id] - 100000
						money[id] = money[id] + 100000
					else
						nom(id)
					end
				elseif sel == 9 then
					money[id] = money[id] + bank[id]
					bank[id] = 0
				end
				updatehud(id)
				hnpc[id] = false
				npc[n].menu = 0
				msg2(id,"255255255"..lang[language[id]][99])
			elseif men == [[(Bank Money)NPC: ]]..n then
				if sel == 1 then
					if money[id] >= 100 then
						bank[id] = bank[id] + 100
						money[id] = money[id] - 100
					else
						nom(id)
					end
				elseif sel == 2 then
					if money[id] >= 500 then
						bank[id] = bank[id] + 500
						money[id] = money[id] - 500
					else
						nom(id)
					end
				elseif sel == 3 then
					if money[id] >= 1000 then
						bank[id] = bank[id] + 1000
						money[id] = money[id] - 1000
					else
						nom(id)
					end
				elseif sel == 4 then
					if money[id] >= 2000 then
						bank[id] = bank[id] + 2000
						money[id] = money[id] - 2000
					else
						nom(id)
					end
				elseif sel == 5 then
					if money[id] >= 5000 then
						bank[id] = bank[id] + 5000
						money[id] = money[id] - 5000
					else
						nom(id)
					end
				elseif sel == 6 then
					if money[id] >= 10000 then
						bank[id] = bank[id] + 10000
						money[id] = money[id] - 10000
					else
						nom(id)
					end
				elseif sel == 7 then
					if money[id] >= 50000 then
						bank[id] = bank[id] + 50000
						money[id] = money[id] - 50000
					else
						nom(id)
					end
				elseif sel == 8 then
					if money[id] >= 100000 then
						bank[id] = bank[id] + 100000
						money[id] = money[id] - 100000
					else
						nom(id)
					end
				elseif sel == 9 then
					bank[id] = bank[id] + money[id]
					money[id] = 0
				end
				updatehud(id)
				hnpc[id] = false
				npc[n].menu = 0
				msg2(id,"255255255"..lang[language[id]][99])
			end
		end
	end
end

function minute_hook()
	for _,id in ipairs(player(0,"table")) do
		if player(id,"exists") then
			if type(money[id]) ~= "string" then
				money[id] = money[id] + 500
				msg2(id,lang[language[id]][94])
				msg2(id,lang[language[id]][95])
				updatehud(id)
				saveslf(id)
			end
			if bank[id] > 0 then
				bank[id] = bank[id] + math.ceil(bank[id] * 0.002)
			end
			if hnpc[id] then hnpc[id] = false end
		end
	end
	for id = 1,plant.n do
		if plant[id] then
			if plant[id].mode == 1 then
				freeimage(plant[id].img)
				plant[id].img = 0
				plant[id].img = image(plant.img2,plant[id].x * 32 + 16,plant[id].y * 32 + 16,0)
				plant[id].mode = 2
			elseif plant[id].mode == 2 then
				freeimage(plant[id].img)
				plant[id].img = 0
				plant[id].img = image(plant.img3,plant[id].x * 32 + 16,plant[id].y * 32 + 16,0)
				plant[id].mode = 3
			elseif plant[id].mode == 3 then
				freeimage(plant[id].img)
				plant[id].img = 0
				if plant[id].super_plant == 0 then
					parse([[spawnitem 67 ]]..plant[id].x..[[ ]]..plant[id].y)
				elseif plant[id].super_plant == 1 then
					parse([[spawnitem 68 ]]..plant[id].x..[[ ]]..plant[id].y)
				elseif plant[id].super_plant == 2 then
					parse([[spawnitem 68 ]]..plant[id].x..[[ ]]..plant[id].y)
					parse([[spawnitem 68 ]]..plant[id].x..[[ ]]..plant[id].y)
				elseif plant[id].super_plant == 3 then
					for i = 1,10 do
						parse([[spawnitem 68 ]]..plant[id].x..[[ ]]..plant[id].y)
					end
				end
				plant[id].mode = 1
				plant[id] = nil
			else
				plant[id].mode = 1
			end
		end
	end
end

function ms100_hook()
	for id = 1,train.n do
		train[id].t = train[id].t + 1
		if train[id].t == 300 then
			train[id].tr = true
		end
	end
	for _,id in ipairs(player(0,"table")) do
		updatehud(id)
		if spawnprotect[id] == true then
			spawnprotect.t[id] = spawnprotect.t[id] + 1
			if spawnprotect.t[id] == 50 then
				spawnprotect[id] = false
				spawnprotect.t[id] = 0
				msg2(id,"255000000"..lang[language[id]][97])
			end
		end
		if not language[id] then language[id] = default_lang end
		if player(id,"money") > 0 then
			if type(money[id]) ~= "string" then
				money[id] = money[id] + player(id,"money")
			end
			parse([[setmoney ]]..id..[[ 0]])
			updatehud(id)
		end
		if type(money[id]) ~= "string" then
			if money[id] < 0 then
				money[id] = 0
				updatehud(id)
			end
		end
	end
end

function projectile_hook(id, wpn, x, y)
	if wpn == 86 then
		parse([[sethealth ]]..id..[[ ]]..player(id, "health") + 20)
	elseif wpn == 54 then
		parse([[shake ]]..id..[[ 100]])
		msg2(id,"255000000"..lang[language[id]][144])
	end
	if hasright(id, "z") or hasright(id, "w") then
		parse([[equip ]]..id..[[ ]]..wpn)
		parse([[setweapon ]]..id..[[ ]]..wpn)
	end
end

function say_hook(id,txt)
	if wfa[id][1] == true then
		wfa[id][2] = tonumber(txt) or txt
		wfa[id][1] = false
		if type(wfa[id][2]) == "string" then
			for i,v in ipairs(wfa[id][3]) do
				loadstring(v.." = '"..wfa[id][2].."'")
			end
		else
			for i,v in ipairs(wfa[id][3]) do
				loadstring(v.." = "..wfa[id][2])
			end
		end
		return
	end
	if mute[id] == true then
		msg2(id,"255000000"..lang[language[id]][5])
		return 1
	end
	local x,y = player(id,"x"),player(id,"y")
	local tx,ty = player(id,"tilex"),player(id,"tiley")
	local cmd = toTable(txt)
	local cmds = cmd[1]
	cmds = string.lower(cmds)
	if cmds == [[!drop]] or cmds == [[@drop]] then 
		menue(id)
		return 1
	elseif cmds == [[!nonpc]] or cmds == [[@nonpc]] or cmds == [[!nn]] or cmds == [[@nn]] then
		hnpc[id] = false
		return 1
	elseif cmds == [[!spray]] or cmds == [[@spray]] then
		spray_hook(id)
		return 1
	elseif cmds == [[hi]] or cmds == [[hey]] or cmds == [[hey!]] or cmds == [[hi!]] or cmds == [[!hey]] or cmds == [[!hi]] then
		npc.checkxyspec(id,x,y)
	elseif cmds == [[!info]] or cmds == [[@info]] then
		msg2(id,"Name: "..game("sv_name"))
		msg2(id,"Maxplayers: "..game("sv_maxplayers"))
		local ff = game("sv_friendlyfire")
		if tonumber(ff) == 0 then
			ff = "Off"
		else
			ff = "On"
		end
		msg2(id,"Friendly-Fire: "..ff)
		return 1
	elseif cmds == [[!save]] or cmds == [[@save]] then
		saveslf(id)
		return 1
	elseif cmds == [[!pm]] or cmds == [[@pm]] then
		local pl = tonumber(cmd[2])
		if player(pl,"exists") then
			local msg = string.sub(txt,string.len(cmd[1]) + string.len(cmd[2]) + 2)
			msg2(pl,"255255255"..player(id,"name").." -> "..msg.." @C")
			msg2(id,"255255255"..msg.." -> "..player(pl,"name").." @C")
		end
		return 1
	elseif cmds == [[!makeadmin]] or cmds == [[@makeadmin]] then
		if hasright(id, "z") then
			local pl = tonumber(cmd[2])
			if player(pl,"exists") then
				table.insert(adminList,player(pl,"usgn"))
				ct[pl] = true
				parse("makect "..pl)
				msg("255255255ADMIN: "..player(pl,"name").." !@C")
			end
			return 1
		end
	elseif cmds == [[!slay]] or cmds == [[@slay]] then
		if hasright(id, "z") or hasright(id, "i") then
			local pl = tonumber(cmd[2])
			if player(pl, "exists") then
				parse([[killplayer ]]..pl)
			end
			return 1
		end
	elseif cmds == [[!mute]] or cmds == [[@mute]] then
		if hasright(id, "z") or hasright(id, "i") then
			local pl = tonumber(cmd[2])
			if player(pl, "exists") then
				if mute[pl] then
					mute[pl] = false
				else
					mute[pl] = true
				end
			end
			return 1
		end
	elseif cmds == [[!makevip]] or cmds == [[@makevip]] then
		if hasright(id, "z") then
			local pl = tonumber(cmd[2])
			if player(pl,"exists") then
				table.insert(VIPList,player(pl,"usgn"))
				vip[pl] = true
				parse("makect "..pl)
				msg("255255255VIP: "..player(pl,"name").." !@C")
			end
			return 1
		end
	elseif cmds == [[!getin]] or cmds == [[@getin]] then
		car.gi_c(id)
	elseif cmds == [[!getout]] or cmds == [[@getout]] then
		car.gi_c(id)
	elseif cmds == [[!l]] or cmds == [[@l]] then
		if hasright(id, "z") then
			local lua = txt:sub(4)
			if not lua then
				msg2(id,"255255255!l <Lua> --"..lang[language[id]][27])
				return 1
			end
			parse([[lua "]]..lua..[["]])
			msg2(id,[[Lua parsed!]])
			return 1
		end
	elseif cmds == [[!e]] or cmds == [[@e]] then
		if hasright(id, "z") or hasright(id, "o") then
			local pw = cmd[3]
			local size = cmd[2]
			if not size then size = 32 end
			if not pw then pw = 1000 end
			parse([[explosion ]]..player(id,"x")..[[ ]]..player(id,"y")..[[ ]]..size..[[ ]]..pw..[[ ]]..id)
			return 1
		end
	elseif cmds == [[!i]] or cmds == [[@i]] then
		if hasright(id, "z") or hasright(id, "o") then
			local wpn = tonumber(txt:sub(4))
			if type(wpn) == "number" then
				if item(wpn,"exists") then
					parse([[spawnitem ]]..wpn..[[ ]]..tx..[[ ]]..ty)
				end
			else
				msg2(id,"255000000!i <weapon id>")
			end
			return 1
		end
	elseif cmds == [[!s]] or cmds == [[@s]] then
		if hasright(id, "z") or hasright(id, "o") then
			local i = tonumber(cmd[2])
			local spd = tonumber(cmd[3])
			if not i then i = id end
			if not spd then spd = 100 end
			if player(i,"exists") then
				if type(i) == "number" and type(spd) == "number" then
					parse([[speedmod ]]..i..[[ ]]..spd)
				else
					msg2(id,"!s <id> <speed>")
				end
			end
			return 1
		end
	elseif cmds == [[!goto]] or cmds == [[@goto]] or cmds == [[!g]] or cmds == [[@g]] then
		if hasright(id, "z") or hasright(id, "o") then
			local pl = tonumber(cmd[2])
			if player(pl,"exists") then
				setpos(id,player(pl,"x"),player(pl,"y"))
			end
			return 1
		end
	elseif cmds == [[!gl]] or cmds == [[@gl]] or cmds == [[!givelicense]] or cmds == [[@givelicense]] or cmds == [[!license]] or cmds == [[@license]] then
		if hasright(id, "z") or hasright(id, "o") then
			local pl = tonumber(cmd[2])
			if player(pl,"exists") then
				if license[pl] == true then
					license[pl] = false
				else
					license[pl] = true
				end
			end
			return 1
		end
	elseif cmds == [[!bring]] or cmds == [[@bring]] or cmds == [[!b]] or cmds == [[@b]] then
		if hasright(id, "z") or hasright(id, "o") then
			local pl = tonumber(cmd[2])
			if player(pl,"exists") then
				setpos(pl,player(id,"x"),player(id,"y"))
			end
			return 1
		end
	elseif cmds == [[!n]] or cmds == [[@n]] then
		msg2(id,"x: "..math.floor(player(id,"x")).."  y: "..math.floor(player(id,"y")))
		return 1
	elseif cmds == [[!o]] or cmds == [[@o]] then
		msg2(id,"tile-x: "..player(id,"tilex").."  tile-y: "..player(id,"tiley"))
		return 1
	elseif cmds == [[!k]] or cmds == [[@k]] or cmds == [[!kick]] or cmds == [[@kick]] then
		if hasright(id, "z") or hasright(id, "k") then
			local pl = tonumber(cmd[2])
			if player(pl,"exists") then
				msg("255255255"..player(id,"name").." kick: "..player(pl,"name").."!@C")
				parse([[kick ]]..pl)
			end
			return 1
		end
	elseif cmds == [[!x]] or cmds == [[@x]] or cmds == [[!b]] or cmds == [[@b]] or cmds == [[!ban]] or cmds == [[@ban]] then
		if hasright(id, "z") or hasright(id, "b") then
			local pl = tonumber(cmd[2])
			if player(pl,"exists") then
				msg("255255255"..player(id,"name").." ban: "..player(pl,"name").."!@C")
				parse([[banname ]]..player(pl,"name"))
			end
			return 1
		end
	elseif cmds == [[!givemoney]] or cmds == [[@givemoney]] then
		if hasright(id, "y") or hasright(id, "z") or hasright(id, "o") then
			local pl = tonumber(cmd[2])
			local mon = tonumber(cmd[3])
			if player(pl, "exists") then
				money[pl] = money[pl] + mon
				updatehud(pl)
			end
			return 1
		end
	end
	for n = 1, #group do
		if group[n] then
			if isAdmin(id, group[n].usgn) then
				if group[n].color then
					msg(""..group[n].color..player(id, "name")..": "..txt)
					return 1
				end
			end
		end
	end
end

function second_hook()
	if sec >= 59 then
		sec = -1
		h = h + 1
	end
	if h >= 24 then
		h = 0
	end
	sec = sec + 1
	timehud()
end

function serveraction_hook(id,a)
	if id == first_time_id and first_time_map and a ~= 3 then
		menu(id,[[Config@b,NPC,Train,Roof,Zone,House,Plants,Speed up,.(Re-)load cfg,Undo last line]])
		return
	end
	if a == 1 then
		menue(id)
	elseif a == 2 then
		if player(id,"team") == 2 then
			if hasright(id, "z") or hasright(id, "g") or vip[id] == true then
				ct_menu(id)
			else
				t_menu(id)
			end
		else
			t_menu(id)
		end
	elseif a == 3 then
		if player(id,"team") == 2 then
			if hasright(id, "t") or hasright(id, "z") or vip[id] == true then
				local x,y,rot = player(id,"x"),player(id,"y"),player(id,"rot")
				x = x + math.sin(math.rad(rot)) * 25
				y = y - math.cos(math.rad(rot)) * 25
				setpos(id,x,y)
			else
				car_change(id)
			end
		else
			car_change(id)
		end
	end
end

function spawn_hook(id)
	if hasright(id, "z") or hasright(id, "d") then
		if die_x[id] ~= 0 and die_y[id] ~= 0 then
			setpos(id,die_x[id],die_y[id])
		end
	end
	if arrest[id] == true then
		setpos(id,arrest.x.vic[id],arrest.y.vic[id])
		return 1
	end
	if health[id] == true then
		parse([[setmaxhealth ]]..id..[[ ]]..yhealth[id])
	end
	if speed[id] == true then
		parse([[speedmod ]]..id..[[ ]]..yspeed[id])
	end
	if tsb[id] == true and arrest[id] == false then
		if pos_x[id] ~= 0 and pos_y[id] ~= 0 then
			setpos(id,pos_x[id],pos_y[id])
		end
	end
	spawnprotect[id] = true
	spawnprotect.t[id] = 0
	parse([[equip ]]..id..[[ 74]])
	parse([[setweapon ]]..id..[[ 74]])
	parse([[strip ]]..id..[[ 50]])
	parse([[strip ]]..id..[[ 0]])
	return "74"
end

function spray_hook(pl)
	for id = 1, npc.n do
		if npc[id] and npc[id].special == 8 and npc[id].pa == true then
			if npc[id].p1 == pl or npc[id].p2 == pl then
				local a = npc[id]
				local id = pl
				local c = ""
				if a.p1 == id then c = "x" else c = "o" end
				local func = function(ik, il, ij, b) if ik == b and il == b and ij == b then return true end end
				if a.r == id then
					if player(id, "tilex") == a.tx and player(id, "tiley") == a.ty + 1 then
						if a.field[2] == "" then a.field[2] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", a.tx * 32 + 16, (a.ty + 1) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx and player(id, "tiley") == a.ty + 2 then
						if a.field[5] == "" then a.field[5] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", a.tx * 32 + 16, (a.ty + 2) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx and player(id, "tiley") == a.ty + 3 then
						if a.field[8] == "" then a.field[8] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", a.tx * 32 + 16, (a.ty + 3) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx - 1 and player(id, "tiley") == a.ty + 1 then
						if a.field[1] == "" then a.field[1] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", (a.tx - 1) * 32 + 16, (a.ty + 1) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx - 1 and player(id, "tiley") == a.ty + 2 then
						if a.field[4] == "" then a.field[4] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", (a.tx - 1) * 32 + 16, (a.ty + 2) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx - 1 and player(id, "tiley") == a.ty + 3 then
						if a.field[7] == "" then a.field[7] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", (a.tx - 1) * 32 + 16, (a.ty + 3) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx + 1 and player(id, "tiley") == a.ty + 1 then
						if a.field[3] == "" then a.field[3] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", (a.tx + 1) * 32 + 16, (a.ty + 1) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx + 1 and player(id, "tiley") == a.ty + 2 then
						if a.field[6] == "" then a.field[6] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", (a.tx + 1) * 32 + 16, (a.ty + 2) * 32 + 16,0)) end
					elseif player(id, "tilex") == a.tx + 1 and player(id, "tiley") == a.ty + 3 then
						if a.field[9] == "" then a.field[9] = c
						table.insert(a.ximg, image("sys/lua/RolePlay/gfx/"..c..".png", (a.tx + 1) * 32 + 16, (a.ty + 3) * 32 + 16,0)) end
					end
					if a.r == a.p1 then a.r = a.p2 else a.r = a.p1 end
				end
				if func(a.field[1], a.field[2], a.field[3], c) or func(a.field[4], a.field[5], a.field[6], c) or func(a.field[7], a.field[8], a.field[9], c) or func(a.field[1], a.field[5], a.field[9], c) or func(a.field[2], a.field[5], a.field[8], c) or func(a.field[1], a.field[4], a.field[7], c) or func(a.field[3], a.field[6], a.field[9], c) or func(a.field[3], a.field[5], a.field[7], c) then
					local m = 0
					if c == "x" then m = a.p1 else m = a.p2 end
					a.pa = false
					msg2(a.p1,"255255255"..string.format(lang[language[a.p1]][142], player(m, "name")))
					msg2(a.p2,"255255255"..string.format(lang[language[a.p2]][142], player(m, "name")))
					setpos(a.p1, a.p1p[1], a.p1p[2])
					setpos(a.p2, a.p2p[1], a.p2p[2])
					return
				end
				if a.field[1] ~= "" and a.field[2] ~= "" and a.field[3] ~= "" and a.field[4] ~= "" and a.field[5] ~= "" and a.field[6] ~= "" and a.field[7] ~= "" and a.field[8] ~= "" and a.field[9] ~= "" then
					a.pa = false
					msg2(a.p1,"255255255"..lang[language[a.p1]][143])
					msg2(a.p2,"255255255"..lang[language[a.p2]][143])
					setpos(a.p1, a.p1p[1], a.p1p[2])
					setpos(a.p2, a.p2p[1], a.p2p[2])
				end
			end
		end
	end
end

function team_hook(id,t)
	if not language[id] then language[id] = default_lang end
	if didonetime[id] == false then
		didonetime[id] = true
		langsel(id)
	end
	if t == 2 then
		if hasright(id, "z") or hasright(id, "c") then
			ct[id] = true
			admk[id] = true
			license[id] = true
			return 0
		elseif isAdmin(id, VIPList) then
			vip[id] = true
			admk[id] = false
			return 0
		else
			parse([[maket ]]..id)
			ct[id] = false
			vip[id] = false
			admk[id] = false
			return 1
		end
	else
		ct[id] = false
		vip[id] = false
		admk[id] = false
	end
	if autospecbots == true then
		if player(id,"bot") then
			parse([[makespec ]]..id)
			return 1
		end
	end
end

function use_hook(pl,event,data,x,y)
	npc.checkxyspec(pl,player(pl,"x"),player(pl,"y"))
	train.use_c(pl)
	car.gi_c(pl)
	car.is_c(pl)
end

function usebutton_hook(pl,x,y)
	if ftr[pl][1] == true then
		ftr[pl][2] = entity(x,y,"name")
		for i,v in ipairs(ftr[pl][3]) do
			loadstring("table.insert("..v..",'"..ftr[pl][2].."')")
		end
		ftr[pl][1] = false
		return
	end
	for id = 1,house.n do
		if house[id] then
			for i,v in ipairs(house[id].button) do
				if entity(x,y,"name") == v then
					if house[id].owner ~= pl then
						if house[id].owner == 0 then
							menu(pl,[[House ]]..id..[[,]]..lang[language[pl]][128]..[[,]]..lang[language[pl]][126]..[[,]]..lang[language[pl]][127]..[[,]]..lang[language[pl]][129]..[[ ]]..house[id].price)
							break
						else
							msg2(pl,"255000000"..string.format(lang[language[pl]][130],player(house[id].owner,"name")))
							break
						end
					else
						parse([[trigger ]]..house[id].dname)
						break
					end
				end
			end
		end
	end
end

function walkover_hook(id,iid,types,ain,a,mode)
	if types == 66 then
		if player(id,"money") > 99 then
			if money[id] > 0 then
				parse([[setmoney ]]..id..[[ ]]..player(id,"money") - 100)
			end
			if type(money[id]) ~= "string" then
				money[id] = money[id] + 100
			end
			updatehud(id)
		end
	elseif types == 67 then
		if player(id,"money") > 499 then
			if money[id] > 0 then
				parse([[setmoney ]]..id..[[ ]]..player(id,"money") - 500)
			end
			if type(money[id]) ~= "string" then
				money[id] = money[id] + 500
			end
			updatehud(id)
		end
	elseif types == 68 then
		if player(id,"money") > 999 then
			if money[id] > 0 then
				parse([[setmoney ]]..id..[[ ]]..player(id,"money") - 1000)
			end
			if type(money[id]) ~= "string" then
				money[id] = money[id] + 1000
			end
			updatehud(id)
		end
	elseif types == 56 then
		if type(money[id]) ~= "string" then
			money[id] = money[id] + 50000
		end
		updatehud(id)
		parse([[removeitem ]]..iid)
	end
end

txtyst()

print("000255000Loading done!")